
#include "Client.h"


HANDLE SemHandle=CreateSemaphore(NULL,0,1,"ClientSemaphore");

/***** TCPClient ******/

ClientRunner::ClientRunner(int portTCP, int portMULTICAST, char* remote, char* group):TCPlistenport(portTCP),MULTICASTlistenport(portMULTICAST),remoteaddr(remote),groupaddr(group){
	InitSockets();
	proto = new IradisProtocolMarshalling(this,' ');
};


void ClientRunner::SendTCP(CStringList* com){
	
	CTCPDialog* pTCPThread = (CTCPDialog *) Threads.GetAt(Threads.FindIndex(1));
	pTCPThread->params=com;
	ReleaseSemaphore(SemHandle,1,NULL);
}

void ClientRunner::Connect(){

		HANDLE *tabHandle = new HANDLE[2];
		
		//-- MULTICAST LAUNCH
		CMULTICASTDialog* pMULTICASTThread = (CMULTICASTDialog*) AfxBeginThread(RUNTIME_CLASS(CMULTICASTDialog),THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
		pMULTICASTThread->SetListenPort(MULTICASTlistenport);
		pMULTICASTThread->SetGroupAddr(groupaddr);
		pMULTICASTThread->client=this;
		Threads.AddTail(pMULTICASTThread);
		pMULTICASTThread->ResumeThread();

		//-- TCP LAUNCH
		CTCPDialog* pTCPThread = (CTCPDialog*) AfxBeginThread(RUNTIME_CLASS(CTCPDialog),THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
		pTCPThread->SetPort(TCPlistenport);
		pTCPThread->SetRemoteAddr(remoteaddr);
		pTCPThread->client=this;
		Threads.AddTail(pTCPThread);
		pTCPThread->ResumeThread();


};

void ClientRunner::Close(){
cout << "ServerRunner::Close Enter\n";
	
		POSITION pos; 
		
		
		// KILL THEM ALL
	
		// KILL the Multicast Thread ! 
		pos = Threads.GetHeadPosition();

		CMULTICASTDialog* pMULTICASTThread= (CMULTICASTDialog *) Threads.GetAt(pos);
		
		pMULTICASTThread->Close();
		Threads.RemoveHead();
		
//		WaitForSingleObject(pMULTICASTThread->m_hThread,INFINITE);
		cout << "ClientRunner::Close Multicast Thread removed\n";

		// KILL the TCP Thread !  
		pos = Threads.GetHeadPosition();
		CTCPDialog* pTCPThread= (CTCPDialog *) Threads.GetAt(pos);
		
		pTCPThread->Close();
		Threads.RemoveHead();
		
//		WaitForSingleObject(pTCPThread->m_hThread,INFINITE);
		cout << "ClientRunner::Close TCP Thread removed\n";

		//Destroy the Sockets
		cout << "ClientRunner::Close Leave\n";

		WSACleanup();




}

/***** CTCPDialog ******/


IMPLEMENT_DYNCREATE(CTCPDialog, CWinThread)

CTCPDialog::CTCPDialog():quit(false){};

CTCPDialog::~CTCPDialog(){};


void CTCPDialog::Close(){
	shutdown(listenport,2);
	closesocket(listenport);
	CloseHandle(this->m_hThread);
};

void CTCPDialog::SetPort(int port){
	listenport=port;
};

int CTCPDialog::Run(){
	//-- Client Connection is established --		
	while(1){

		WaitForSingleObject(SemHandle,INFINITE);
		client->proto->sendMsg(sock_Listen_TCP,client->proto->invoke(params));
		CString* received=client->proto->receiveMsg(sock_Listen_TCP);
		cout <<"result received: " << received->GetBuffer(0) << endl;
		
		if ( !strcmp(received->GetBuffer(0),"202") ){
			//It's time to quit
			cout << "goodbye" <<"\n";
			client->Close();
		}
		
	};	

	return 0;
}

BOOL CTCPDialog::InitInstance(){
	InitTCP();
	return TRUE;
};

int CTCPDialog::ExitInstance(){
	return 0;
};



void CTCPDialog::SetRemoteAddr(char * remote){
	remoteaddr=remote;
};


void CTCPDialog::InitTCP(){
	SOCKADDR_IN	addr_Dest;

	// -- Create TCP socket
	if ((sock_Listen_TCP = socket(AF_INET, SOCK_STREAM,0)) < 0){
		cout<<"Error: socket() failed.\n";
		Close();		
		//exit(0);
	}

	//-- Fill in target addr
	memset((char *) &addr_Dest, 0, sizeof(addr_Dest));
	addr_Dest.sin_family      = AF_INET;
	addr_Dest.sin_addr.s_addr = inet_addr(remoteaddr);
	addr_Dest.sin_port        = htons((short)listenport);	
	
	//-- Connect to destination
	if (connect(sock_Listen_TCP, (sockaddr*) &addr_Dest, sizeof(addr_Dest)) <0){
		cout<<"Error: connect() failed.\n";
		Close();		
		//exit(0);
	}

}


/*** CMULTICASTDialog ***/






IMPLEMENT_DYNCREATE(CMULTICASTDialog, CWinThread)

CMULTICASTDialog::CMULTICASTDialog(){};

CMULTICASTDialog::~CMULTICASTDialog(){};
	

void CMULTICASTDialog::Receive(char* buff, int* size){
	memset(&addr_Srv,0,sizeof(addr_Srv));
	int sizeadr=sizeof(addr_Srv);
	if ((*size=recvfrom(sock_Listen_MULTICAST,buff,256,0,(sockaddr*)&addr_Srv,&sizeadr))==SOCKET_ERROR){
		cout<<"Error: recvfrom() failed.\n";
		Close();		
		//exit(0);
	}

};
	
void CMULTICASTDialog::SetListenPort(int port){
	listenport=port;
};

void CMULTICASTDialog::SetGroupAddr(char *group){
	groupaddr=group;
};

void CMULTICASTDialog::InitMULTICAST(){
	 SOCKADDR_IN		addr_Clt;
	 //	 struct in_addr In_Addr;
	//-- Create UDP Socket
	if ((sock_Listen_MULTICAST = socket(AF_INET, SOCK_DGRAM, 0)) < 0){
		cout<<"Error: socket() failed.\n";
		exit(0);
	}
	
		//-- Fill in structure fields for binding to localhost
	memset((char *) &addr_Clt, 0, sizeof(addr_Clt));
	addr_Clt.sin_family      = AF_INET;
	addr_Clt.sin_addr.s_addr = htonl(INADDR_ANY);
	addr_Clt.sin_port        = htons((short)listenport);

    //-- Bind it
	if (bind(sock_Listen_MULTICAST, (sockaddr*) &addr_Clt, sizeof(addr_Clt)) < 0){
		
		cout<<"Error: bind() failed.\n";
		printf("%s\n",getWinsockStrError(WSAGetLastError()));
		Close();		

		//exit(0);
	}
	

	struct ip_mreq mreq; 
	int err;

	mreq.imr_multiaddr.s_addr = inet_addr(groupaddr);
	mreq.imr_interface.s_addr = INADDR_ANY;
	if ((err = setsockopt(sock_Listen_MULTICAST, IPPROTO_IP, IP_ADD_MEMBERSHIP,(char*)&mreq, sizeof(mreq)))==SOCKET_ERROR){ 
		cout<<"Error: setsockopt() failed.\n";
		Close();
		//exit(0);
	} 

	
};

void CMULTICASTDialog::Close(){
	shutdown(listenport,2);
	closesocket(listenport);
	CloseHandle(this->m_hThread)	;

};

int CMULTICASTDialog::Run(){
	int size;
	char* buffer=new char[256];
	while(1){

		Receive(buffer,&size);
		buffer[size]='\0';
		printf("MULTICAST ");
		printf(buffer);
	}
	return 0;
}
	
BOOL CMULTICASTDialog::InitInstance(){
	InitMULTICAST();
	return TRUE;
};

int CMULTICASTDialog::ExitInstance(){return 0;};


void main(){
	
	int port = 1550; 
	ClientRunner client(1550,2001,"127.0.0.1","230.3.3.3");
	client.Connect();
	CStringList* params=new CStringList();
	
	params->AddTail("LOGOUT");
	params->AddTail("stoss");
	params->AddTail("stoss");

	client.SendTCP(params);

	Sleep(30000);

}
	