#ifndef _CLIENT_H
#define _CLIENT_H

#include <Afxsock.h>
#include <Afxtempl.h>
#include "Message.h"
#include "ProtocolMarshalling.h"
#include "utils.h"
#include <Windows.h>

extern HANDLE SemHandle;

using namespace std;




class ClientRunner {
	
	public:
		ClientRunner(int portTCP,int portMULTICAST, char* remote, char* group);

		void SendTCP(CStringList* com);

		void Connect();

		void Close();

	public:
		int TCPlistenport;
		int MULTICASTlistenport;
		char* remoteaddr;
		char* groupaddr;
		IradisProtocolMarshalling *proto;
		CList<CWinThread *,CWinThread *> Threads;
	
};

class CTCPDialog:public CWinThread {
	
DECLARE_DYNCREATE(CTCPDialog)

	protected:

		CTCPDialog();

		virtual ~CTCPDialog();
	
	public:
	
		void SetPort(int port);

		void InitTCP();

		void Close();
	
		virtual BOOL InitInstance();

		virtual int ExitInstance();

		virtual int Run();

		void SetRemoteAddr(char * remote);

	public:
		int				listenport;
		SOCKET			sock_Listen_TCP;
		char*			remoteaddr;
		BOOL			quit;
		ClientRunner*   client;
		CStringList*    params;

};

class CMULTICASTDialog:public CWinThread {
	
DECLARE_DYNCREATE(CMULTICASTDialog)

	protected:

		CMULTICASTDialog();

		virtual ~CMULTICASTDialog();
	
	public:

		void Receive(char* buff, int* size);
	
		void SetListenPort(int port);
		
		void SetGroupAddr(char *group);

		void InitMULTICAST();

		void Close();
	
		virtual BOOL InitInstance();

		virtual int ExitInstance();

		virtual int Run();

		void Send(char* buff, int size, char *group);


	public:
		int				listenport;
		SOCKET			sock_Listen_MULTICAST;
		char*			groupaddr;
		SOCKADDR_IN		addr_Srv;
		ClientRunner*    client;


};




#endif