// -----------------------------------------------------------------------
#include "stdafx.h"
#include "DocInfo.h"
// -----------------------------------------------------------------------

IMPLEMENT_SERIAL(CDocInfo , CObject, 1)

CDocInfo::CDocInfo() { }
CDocInfo::CDocInfo(CString filename, CString owner, CString relativePath,
              CString mimetype, BOOL streamable, BOOL persistent,
              CString description) : filename(filename), owner(owner),
              relativePath(relativePath), mimetype(mimetype),
              streamable(streamable), persistent(persistent), description(description) { }
// -----------------------------------------------------------------------
CDocInfo::CDocInfo (CDocInfo& doc) {
	filename = doc.filename;
	owner = doc.owner;
	relativePath = doc.relativePath;
	mimetype = doc.mimetype; 
    streamable = doc.streamable;
    persistent = doc.persistent;
    description = doc.description;	
}
// -----------------------------------------------------------------------
CDocInfo& CDocInfo::operator= (CDocInfo& doc) {
	filename = doc.filename;
	owner = doc.owner;
	relativePath = doc.relativePath;
	mimetype = doc.mimetype; 
    streamable = doc.streamable;
    persistent = doc.persistent;
    description = doc.description;		
	return doc;
};
// -----------------------------------------------------------------------
void CDocInfo::Serialize(CArchive &archive)
{
  CObject::Serialize( archive );

  if (archive.IsStoring()) {
    archive << filename << owner << relativePath << mimetype << streamable << persistent << description;
  } else {
    archive >> filename >> owner >> relativePath >> mimetype >> streamable >> persistent >> description;
  }
}
// -----------------------------------------------------------------------
CString CDocInfo::getKey() {
  return owner+filename;
}
// -----------------------------------------------------------------------