// DocInfoManager.cpp: implementation of the DocInfoManager class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "DocInfoManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DocInfoManager::DocInfoManager(CString FileName)
{
  pDocTable = new IRadDataTable<CDocInfo>(FileName);
}

DocInfoManager::~DocInfoManager()
{
  delete pDocTable;
}


BOOL DocInfoManager::RegisterDocument(CDocInfo *di)
{
  return pDocTable->AddRecord(di);
}

BOOL DocInfoManager::UnRegisterDocument(CString Owner_Filename)
{
  return pDocTable->DeleteRecord(Owner_Filename);
}

BOOL DocInfoManager::DocumentExists (CString owner, CString filename)
{
  return ( pDocTable->FindRecord(owner+filename) != NULL);
}

CDocInfo* DocInfoManager::GetDocInfo (CString Owner_Filename)
{
  return pDocTable->FindRecord(Owner_Filename);
}

void DocInfoManager::ClearDataBase()
{
  pDocTable->ClearAll();
}
  

void DocInfoManager::Flush()
{
 pDocTable->Flush ();

}

IRadDataTable<CDocInfo>* DocInfoManager::GetListAll()
{
	return pDocTable;
}
