#include "StdAfx.h"
#include "Event.h"


///////////////////////////////////////////
//  EVENT
///////////////////////////////////////////

Event::Event(int msg, LPCTSTR * args, int nbargs){

	message = msg;
	params = args;
	nbparams = nbargs;

}

Event::~Event() {
	if(params != NULL)
		delete params;
}

int Event::getMessageCode(){
	return message;
}


// retourne le message correspondant au code message
LPCTSTR Event::getMessage(){
	switch(message) {
		case USER_NEW:
			return "USER_NEW";			
		case USER_DEL:
			return "USER_DEL";
		case USER_ONLINE:
			return "USER_ONLINE";
		case USER_OFFLINE:
			return "USER_OFFLINE";
		case DOC_NEW:
			return "DOC_NEW";
		case DOC_DEL:
			return "DOC_DEL";
		case DOC_START:
			return "DOC_START";
		case DOC_STOP:
			return "DOC_STOP";
		default:
			return "ERROR";
	}

}

// retourne la liste des paramters
LPCTSTR * Event::getParams(){
	return params;
}

// retourne un paramtre  la position donn
LPCTSTR Event::getParam(int pos){
	if (pos < nbparams) {
		return params[pos];
	} else {
		return "";
	}
}

// retourne le nb de paramtres
int Event::getNbParams(){
	return nbparams;
}

// fonction de test
/*
void main(){
	
	int i;

	// test event
	LPSTR params[10];
	params[0] = "lotso";
	params[1] = "lldk";
	params[2] = "ttotot";

	Event * e = new Event(1, (LPCTSTR *) params, 3);
	
	cout << "\nje fais un : new  Event(1, lotso + lldk + ttotot, 3) \n";
	cout << "----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}
	

	// test new user online
	LPCTSTR login = "titttti";
	e = new UserOnlineEvent(login);
	cout << "\nje fais un : new UserOnlineEvent(titi) \n";
	cout << "----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}
	

	// test new document		
	e = new NewDocEvent("titi", "ffl.txt");	
	cout << "\nje fais un : new NewDocEvent(titi, ffl.txt) \n";
	cout << "-----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}

	// test start sending document		
	e = new StartSendingDocEvent("titi", "ffl.txt", "224.0.0.1",80);
	cout << "\nje fais un : new StartSendingDocEvent(titi, ffl.txt, 224.0.0.1, 80) \n";
	cout << "-----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}

	// test del document
	e = new StopSendingDocEvent("titi", "ffl.txt");	
	cout << "\nje fais un : new StopSendingDocEvent(titi, ffl.txt) \n";
	cout << "-----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}

	// test del document
	e = new DelDocEvent("titi", "ffl.txt");	
	cout << "\nje fais un : new DelDocEvent(titi, ffl.txt) \n";
	cout << "-----------------------------------------\n";
	cout << "\n";
	cout << "getMessage() : " << e->getMessage() << "\n";
	cout << "getNbParams() : " << e->getNbParams() << "\n";
	cout << "\nLes parametres : \n";
	for (i=0; i< e->getNbParams(); i++) {
		cout << i << " : " << e->getParam(i) << "\n";
	}
}
*/
//void ServerListener::OnNewEvent(Event e){}