// FcastSenderThread.cpp : implementation file
//

#include "stdafx.h"
#include "Server.h"
#include "FcastSenderThread.h"
#include "Fcast_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// FcastSenderThread

IMPLEMENT_DYNCREATE(FcastSenderThread, CWinThread)

FcastSenderThread::FcastSenderThread()
{
	HRESULT hr;	
	hr = CoInitialize(NULL);
	
	OutputDebugString( FAILED(hr) ? "CoInitialize FcastSenderThread() KO\n" : "CoInitialize FcastSenderThread() OK\n");

	// Register Fcast ActivX DLL
	HINSTANCE hOleServerInst = LoadLibrary("Fcast.dll");
	if(hOleServerInst == 0)
	{
		AfxMessageBox("Can't load Fcast.dll");
	} else {
		HRESULT (STDAPICALLTYPE *pfnRegServer)(void);
		(FARPROC&)pfnRegServer = GetProcAddress(hOleServerInst, _T("DllRegisterServer"));
		if(pfnRegServer == NULL)
		{
			AfxMessageBox("Can't find DllRegisterServer in Fcast.dll");
		} else {
			//CoInitialize(NULL);
			HRESULT hResult = (*pfnRegServer)();
			if( FAILED(hResult) )
			{
				AfxMessageBox("Can't register Fcast.dll");
			} else {
				OutputDebugString("Fcast.dll successfully registered.\n");
				CoFreeLibrary(hOleServerInst);
			}
		}
	}
	

	hr = CoCreateInstance(CLSID_FcastSnd, NULL,
		CLSCTX_ALL, IID_IDispatch, (void**) &pIFcastSnd);
	OutputDebugString( FAILED(hr) ? "CoCreateInstance Send KO\n" : "CoCreateInstance Send OK\n");

}

FcastSenderThread::~FcastSenderThread()
{
	CoUninitialize( );
}

BOOL FcastSenderThread::InitInstance()
{
	VARIANT pvSentCount, pvSentRounds, pvCurrentIndex,
		pvComplete,pvErrorCode;

	HRESULT hr;
	// TODO:  perform and per-thread initialization here
	while(1) {
		CString temp;
		temp.Format("playlist size = %d\n",pServer->playlist->Size());
		OutputDebugString(temp);

		// Check if there is something in playlist
		while(pServer->playlist->Size() <= 0)
			this->SuspendThread();

		pServer->SendFcastInfo();

		// Init Fcast
		hr = pIFcastSnd->Init( FcastIP.AllocSysString(), 
				FcastPort,
				FCAST_TTL,
				(FcastRate * 1024) / 8 );

		OutputDebugString( FAILED(hr) ? "Init Fcast KO\n" : "Init Fcast OK\n");
		
		// Get file to send
		CDocInfo doc = pServer->playlist->GetHead();

		// Retrieve file size
		HANDLE hFile = CreateFile(
			doc.relativePath,     // pointer to name of the file
			GENERIC_READ,           // access (read-write) mode
			NULL,                   // share mode
			NULL,                   // pointer to security attributes
			OPEN_EXISTING,          // how to create
			FILE_ATTRIBUTE_NORMAL,  // file attributes
			NULL                    // handle to file with attributes to copy
		);
			
		if(hFile != NULL) {
			// Try to obtain hFile's size 
			DWORD dwSize = GetFileSize (hFile, NULL);
			CloseHandle(hFile);

			if (dwSize != INVALID_FILE_SIZE) 
			{
				hr = pIFcastSnd->Start(doc.relativePath.AllocSysString());
				if( FAILED(hr) )
				{
					OutputDebugString("FcastSenderThread Start failed\n");
					continue;
				} else {
					OutputDebugString("FcastThread Start OK\n");
				}
				
				unsigned long TotalPacketToSend = ( (dwSize / 1024 ) * FcastRound );

				do {
					Sleep(1000);
					hr = pIFcastSnd->GetStats(&pvSentCount,&pvSentRounds,&pvCurrentIndex,
						&pvComplete,&pvErrorCode);					

					CString temp;
					temp.Format("FileSize = %d, tpts<%d>, sr<%d>, st<%d> \n",dwSize, TotalPacketToSend,
						pvSentRounds.intVal,pvSentCount.intVal);
					OutputDebugString(temp);
				} while ( pvSentCount.intVal < TotalPacketToSend );

				// The file has ben sent
				hr = pIFcastSnd->Stop();
				OutputDebugString("FcastThread Stop\n");
				pServer->playlist->RemoveElementAt(0);
				pServer->Notify(new UpdatePlayListEvent());
			}
		} else {
			OutputDebugString("FcastSendThread incorrect file size.\n");
		}

	}
	
	return TRUE;
}

void FcastSenderThread::StopFcast() {
	pIFcastSnd->Stop();
}

int FcastSenderThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(FcastSenderThread, CWinThread)
	//{{AFX_MSG_MAP(FcastSenderThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FcastSenderThread message handlers
