// FileManager.cpp: implementation of the FileManager class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "FileManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FileManager::FileManager(CString absolutePath)
{
  path = absolutePath;
    // TODO : check if path terminate by "\\" (add it if it don't)
  if(path.Right(1) != "\\") {
    path += "\\";
  }
}

FileManager::~FileManager()
{
  
}


HANDLE FileManager::GetFile (CString login, CString filename)
{
 CString fullname = path + login + "\\" + filename;
 return CreateFile(
    fullname,     // pointer to name of the file
    GENERIC_READ,           // access (read-write) mode
    NULL,                   // share mode
    NULL,                   // pointer to security attributes
    OPEN_EXISTING,          // how to create
    FILE_ATTRIBUTE_NORMAL,  // file attributes
    NULL                    // handle to file with attributes to copy
  );

}

BOOL FileManager::AddFile (CString login, CString filename, CString tmpCompleteFileName)
{ 
	CString definitivePathFile = path + login + "\\" + filename;
  // move the file in the login directory
	return MoveFileEx(tmpCompleteFileName, definitivePathFile,MOVEFILE_REPLACE_EXISTING);
}

BOOL FileManager::DelFile(CString login, CString filename)
{
  //if(FileExists(login,filename)) {
    CString fullname = path + login + "\\" + filename;
    // check if it is well deleted
	return DeleteFile(fullname);
  //} else {
    //return FALSE;
  //}
}

BOOL FileManager::FileExists (CString login, CString filename)
{
  CString fullname = path + login + "\\" + filename;
  HANDLE hFile;
  bool result;

  hFile = CreateFile(
    fullname,     // pointer to name of the file
    GENERIC_READ,           // access (read-write) mode
    NULL,                   // share mode
    NULL,                   // pointer to security attributes
    OPEN_EXISTING,          // how to create
    FILE_ATTRIBUTE_NORMAL,  // file attributes
    NULL                    // handle to file with attributes to copy
  );

  result = (hFile != INVALID_HANDLE_VALUE);

  CloseHandle(hFile);

  return result;

}

CString FileManager::GenerateFilename(CString login, CString filename)
{
  CString fullname = path + login + "\\" + filename;
  HANDLE res;
  int number=0;

  res = CreateFile(
    fullname,     // pointer to name of the file
    GENERIC_READ,           // access (read-write) mode
    NULL,                   // share mode
    NULL,                   // pointer to security attributes
    OPEN_EXISTING,          // how to create
    FILE_ATTRIBUTE_NORMAL,  // file attributes
    NULL                    // handle to file with attributes to copy
  );

  while(res == INVALID_HANDLE_VALUE){
	fullname = path + login + "\\" + IntToString(number) + filename;

	res = CreateFile(
		fullname,				// pointer to name of the file
		GENERIC_READ,           // access (read-write) mode
		NULL,                   // share mode
		NULL,                   // pointer to security attributes
		OPEN_EXISTING,          // how to create
		FILE_ATTRIBUTE_NORMAL,  // file attributes
		NULL                    // handle to file with attributes to copy
	);

	number++;
  }

  return fullname;
}

CString FileManager::IntToString(int number)
{
	char str[10];
	_itoa(number, str, 10);
	return (CString)str;
}