// ManagePlayList.cpp : implementation file
//

#include "stdafx.h"
#include "ServerAudio.h"
#include "ManagePlayList.h"
#include "ManageDocsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define NUM_COL 3

static LPTSTR _colLabel[NUM_COL] = {"File","Owner","Description"};

static int _colWidth[NUM_COL] = {100,70,190};


/////////////////////////////////////////////////////////////////////////////
// CManagePlayList dialog


CManagePlayList::CManagePlayList(CWnd* pParent /*=NULL*/, CServerAudioDoc * doc)
	: CDialog(CManagePlayList::IDD, pParent), m_document(doc)
{
	//{{AFX_DATA_INIT(CManagePlayList)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	cpl = m_document->GetPlayList();
	m_document->cManPlayList=this;
}

CManagePlayList::~CManagePlayList(){
	m_document->cManPlayList=NULL;
}


void CManagePlayList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManagePlayList)
	DDX_Control(pDX, IDC_BTN_INS, m_Btn_Ins);
	DDX_Control(pDX, IDC_DESCRIPTION, m_Edit_Des);
	DDX_Control(pDX, IDC_FILE, m_Edit_File);
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManagePlayList, CDialog)
	//{{AFX_MSG_MAP(CManagePlayList)
	ON_BN_CLICKED(IDC_BTN_UP, OnBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, OnBtnDown)
	ON_BN_CLICKED(IDC_BTN_INS, OnBtnIns)
	ON_BN_CLICKED(IDC_BTN_DEL, OnBtnDel)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManagePlayList message handlers

BOOL CManagePlayList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  // Show full row selection
  DWORD dwStyle;
  dwStyle = m_list.SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE, 0 ,0);
  dwStyle |= LVS_EX_FULLROWSELECT /* |LVS_EX_GRIDLINES */;
  m_list.SendMessage( LVM_SETEXTENDEDLISTVIEWSTYLE, 0,dwStyle );

	// TODO: Add extra initialization here
	int i;
	LV_COLUMN lvc;
	for (i = 0;   i < NUM_COL;   i++) {
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT; //| LVCF_SUBITEM;

//	lvc.iSubItem = i;
		lvc.pszText = _colLabel[i];
		lvc.cx = _colWidth[i];
		lvc.fmt = LVCFMT_LEFT;

		m_list.InsertColumn(i, &lvc);
	}

	
	Fill();
	//m_list.SetFullRowSel(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CManagePlayList::OnBtnUp() 
{
	// TODO: Add your control notification handler code here
	int sel = m_list.GetSelectionMark();

	if (sel > 0) {
		int pos = cpl->ChangePriority(sel,1);
		// TODO : optimize
		Fill();
		m_list.SetFocus ();
		m_list.SetSelectionMark (pos);
		m_list.SetItemState (pos, LVIS_SELECTED,LVIS_SELECTED);
    if(m_document->ServerIsRunning())
      m_document->server->SendPlaylist();

	}
		//m_document->server.test();
}

void CManagePlayList::OnBtnDown() 
{
	// TODO: Add your control notification handler code here
	int sel = m_list.GetSelectionMark();
	if (sel >= 0) {
		int pos = cpl->ChangePriority(sel,-1);
		// TODO : optimize
		Fill();
		m_list.SetFocus ();
		m_list.SetSelectionMark (pos);
		m_list.SetItemState (pos, LVIS_SELECTED,LVIS_SELECTED);
    if(m_document->ServerIsRunning())
      m_document->server->SendPlaylist();
	}
}

void CManagePlayList::OnBtnIns() 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	cpl->Enqueue (tempDoc);
	Fill(); // refresh liste
	

	if(m_document->ServerIsRunning()) {
		m_document->server->SendPlaylist();
		Sleep(500);
		m_document->server->fcastSndThread->ResumeThread();
	}

	// erase and clear
	m_Btn_Ins.EnableWindow(FALSE);
	m_Edit_File.SetWindowText("");
	m_Edit_Des .SetWindowText("");
}

void CManagePlayList::OnBtnDel() 
{
	// TODO: Add your control notification handler code here
	int sel = m_list.GetSelectionMark();
	if(sel >= 0) {
		cpl->RemoveElementAt(sel);
		m_list.DeleteItem(sel);
    if(m_document->ServerIsRunning())
      m_document->server->SendPlaylist();
	} else {
		return;
	}

	if( cpl->Size() <= 0) {
		m_document->server->PlaylistMtx->Lock();
	}

//	Fill();
}

void CManagePlayList::Fill()
{
	int i;
	
	CDocInfo temp;

	m_list.DeleteAllItems();

// insert item

	LV_ITEM lvi;


	for (i = 0;   i < cpl->Size();   i++) {
		lvi.mask = LVIF_TEXT;
		lvi.iItem = i;
		lvi.iSubItem = 0;

		temp = cpl->GetElementAt(i);
		lvi.pszText = temp.filename.GetBuffer(0);

		m_list.InsertItem(&lvi);

	//	m_list.SetItemText(i, 0, temp.filename);
		m_list.SetItemText(i, 1, temp.owner);
		m_list.SetItemText(i, 2, temp.description);
	}


  /*// set item text for additional columns
  for (i = 0;   i < lstExt->size();   i++) {
    m_association_list.SetItemText(i, 0, (*lstExt)[i].ext);
    m_association_list.SetItemText(i, 1, (*lstExt)[i].prog);
  }*/

}

void CManagePlayList::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}


void CManagePlayList::OnBtnBrowse() 
{
	// TODO: Add your control notification handler code here
	CManageDocsDlg mdlg(NULL, m_document, DIALOG_GETFILENAME);

	if (mdlg.DoModal () != IDOK) {
		m_Edit_File.SetWindowText("");
		m_Edit_Des .SetWindowText("");
		return;
	}

	// TO DO: recuperer l'element
	tempDoc = mdlg.selectedDoc;
	m_Edit_File.SetWindowText(tempDoc.filename);
	m_Edit_Des .SetWindowText(tempDoc.description);
	m_Btn_Ins.EnableWindow(TRUE);
}
