// ManageUsersDlg.cpp : implementation file
//
#include "stdafx.h"
#include "ServerAudioDoc.h"
#include "ServerAudio.h"
#include "ManageUsersDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define UNCHECK 0
#define CHECK 1

/////////////////////////////////////////////////////////////////////////////
// CManageUsersDlg dialog

CManageUsersDlg::CManageUsersDlg(CWnd* pParent /*=NULL*/, CServerAudioDoc* doc)
	: CDialog(CManageUsersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManageUsersDlg)
	//}}AFX_DATA_INIT

	// rempli la liste des users Online;	
	m_document = doc;
	m_document->cManageUsersDlg=this;
	m_users_online_list = &(m_document->m_users_online_list);
	m_users_offline_list = &(m_document->m_users_offline_list);
	
}

CManageUsersDlg::~CManageUsersDlg() { }

void CManageUsersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManageUsersDlg)
	DDX_Control(pDX, IDC_NB_UNCON, m_Nb_UnCon);
	DDX_Control(pDX, IDC_NB_CON, m_Nb_Con);
	DDX_Control(pDX, IDC_EDIT_PASS, m_Edit_Pass);
	DDX_Control(pDX, IDC_EDIT_IP, m_Edit_Ip);
	DDX_Control(pDX, IDC_CHK_BAN, m_Chk_Ban);
	DDX_Control(pDX, IDC_EDIT_SURNAME, m_Edit_Surname);
	DDX_Control(pDX, IDC_EDIT_NAME, m_Edit_Name);
	DDX_Control(pDX, IDC_EDIT_LOGIN, m_Edit_Login);
	DDX_Control(pDX, IDC_LIST_USERS_OFFLINE, m_users_offline_listbox);
	DDX_Control(pDX, IDC_LIST_USERS_ONLINE, m_users_online_listbox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManageUsersDlg, CDialog)
	//{{AFX_MSG_MAP(CManageUsersDlg)
	ON_LBN_SETFOCUS(IDC_LIST_USERS_ONLINE, OnSetfocusListUsersOnline)
	ON_LBN_SETFOCUS(IDC_LIST_USERS_OFFLINE, OnSetfocusListUsersOffline)
	ON_BN_CLICKED(IDC_NEW_USER, OnNewUser)
	ON_BN_CLICKED(IDC_DELETE_USERS, OnDeleteUsers)
	ON_BN_CLICKED(IDC_BTN_CLEAR, OnBtnClear)
/*	ON_LBN_DBLCLK(IDC_LIST_USERS_ONLINE, OnDblclkListUsersOnline)
	ON_LBN_DBLCLK(IDC_LIST_USERS_OFFLINE, OnDblclkListUsersOffline)*/
	ON_BN_CLICKED(IDC_EDIT_USER, OnEditUser)
	ON_LBN_SELCHANGE(IDC_LIST_USERS_OFFLINE, OnSelchangeListUsersOffline)
	ON_LBN_SELCHANGE(IDC_LIST_USERS_ONLINE, OnSelchangeListUsersOnline)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManageUsersDlg message handlers

BOOL CManageUsersDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
		
	// TODO: Add extra initialization here
	//m_users_online_listbox.AddString("Nicolas");
	//m_users_online_listbox.AddString("Toff");
	//m_users_online_listbox.AddString("Merdalor");
	//m_users_offline_listbox.AddString("Christos");
	//m_users_offline_listbox.AddString("Dawid");

	NbRefresh();


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CManageUsersDlg::OnSetfocusListUsersOnline() 
{
	// TODO: Add your control notification handler code here
	m_users_offline_listbox.SetCurSel(-1); // enlve la selection de l'autre panel (offline)

	
}

void CManageUsersDlg::OnSetfocusListUsersOffline() 
{
	// TODO: Add your control notification handler code here
	m_users_online_listbox.SetCurSel(-1);
	
}

void CManageUsersDlg::OnNewUser() 
{
	// TODO: Add your control notification handler code here
	CString login;
	m_Edit_Login.GetWindowText(login);
	
	// TODO : Find in database the new login
	if (login == "") {
		MessageBox("Specify a login for the user.","Add User", MB_ICONWARNING|MB_OK);
		m_Edit_Login.SetFocus();
		return;
	} else if (m_document->dbUser->GetUserInfo(login)!=NULL) {
		MessageBox("Login is already used by another user.","Add User", MB_ICONWARNING|MB_OK);
		m_Edit_Login.SetFocus();
		return;
	} 
	
	// set 
	CString  pass, name, surname, ip;
	BOOL banned; 
	m_Edit_Pass.GetWindowText(pass);
	m_Edit_Name.GetWindowText(name);
	m_Edit_Surname.GetWindowText(surname);
	ip = "";
	if (m_Chk_Ban.GetCheck() == CHECK) 
		banned = TRUE;
	else 
		banned = FALSE;
	CUserInfo * ui = new CUserInfo(login, pass, name, surname, banned, false, ip, 0);

	m_document->dbUser->RegisterUser(ui);
	m_users_offline_list->RemoveAll();
	m_users_online_list->RemoveAll();
	m_document->dbUser->GetList(m_users_offline_list,false);
	m_document->dbUser->GetList(m_users_online_list,true);
	
	NbRefresh();
}

void CManageUsersDlg::OnDeleteUsers() 
{
	// TODO: Add your control notification handler code here
	CString login;
	m_Edit_Login.GetWindowText(login);

	BOOL userDel = m_document->dbUser->UnRegisterUser(login);
	if (!userDel) {
		MessageBox("Unknow user.\nDelete user progress abort.","Add User", MB_ICONWARNING|MB_OK);
		m_Edit_Login.SetFocus();
		return;
	} else {
		MessageBox("User " + login + " has been removed from database.","Add User", MB_OK);
	}

	m_users_offline_list->RemoveAll();
	m_users_online_list->RemoveAll();
	m_document->dbUser->GetList(m_users_offline_list,false);
	m_document->dbUser->GetList(m_users_online_list,true);

	NbRefresh();
}

void CManageUsersDlg::OnBtnClear() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Login.SetFocus();
	m_Edit_Login.SetWindowText("");
	m_Edit_Name.SetWindowText("");
	m_Edit_Surname.SetWindowText("");
	m_Edit_Pass.SetWindowText("");
	m_Edit_Ip.SetWindowText("");
	m_Chk_Ban.SetCheck(UNCHECK);
}
/*
void CManageUsersDlg::OnDblclkListUsersOnline() 
{
	// TODO: Add your control notification handler code here
	CString login;
	m_users_online_listbox.GetText(m_users_online_listbox.GetCurSel(), login);
	
	CUserInfo* user = m_document->dbUser->GetUserInfo(login);
	m_Edit_Login.SetWindowText(login);
	m_Edit_Name.SetWindowText(user->user);
	m_Edit_Surname.SetWindowText(user->lastname);
	m_Edit_Pass.SetWindowText(user->passwd);
	if (user->banned == TRUE)
		m_Chk_Ban.SetCheck(CHECK);
	else 
		m_Chk_Ban.SetCheck(UNCHECK);
	m_Edit_Ip.SetWindowText(user->ip);

}

void CManageUsersDlg::OnDblclkListUsersOffline() 
{
	CString login;
	m_users_offline_listbox.GetText(m_users_offline_listbox.GetCurSel(), login);
	
	CUserInfo* user = m_document->dbUser->GetUserInfo(login);
	if (user!= NULL) {
		m_Edit_Login.SetWindowText(login);
		m_Edit_Name.SetWindowText(user->user);
		m_Edit_Surname.SetWindowText(user->lastname);
		m_Edit_Pass.SetWindowText(user->passwd);
		if (user->banned == TRUE)
			m_Chk_Ban.SetCheck(CHECK);
		else 
			m_Chk_Ban.SetCheck(UNCHECK);
		m_Edit_Ip.SetWindowText(user->ip);
	}

}
*/
void CManageUsersDlg::NbRefresh()
{
	m_users_offline_listbox.ResetContent();
	m_users_online_listbox.ResetContent();

	POSITION pos;
	for ( pos = m_users_online_list->GetHeadPosition(); pos != NULL ; ){
		m_users_online_listbox.AddString(m_users_online_list->GetNext(pos));
	}

	for ( pos = m_users_offline_list->GetHeadPosition(); pos != NULL ; ){
		m_users_offline_listbox.AddString(m_users_offline_list->GetNext(pos));
	}

	CString nb; nb.Format(_T("%d users"),m_users_online_listbox.GetCount());
	m_Nb_Con.SetWindowText(nb);
	nb.Format(_T("%d users"),m_users_offline_listbox.GetCount());
	m_Nb_UnCon.SetWindowText(nb);
}

void CManageUsersDlg::OnEditUser() 
{
	// TODO: Add your control notification handler code here
	CString login;
	m_Edit_Login.GetWindowText(login);
	CUserInfo* user = m_document->dbUser->GetUserInfo(login);
	if (user == NULL) {
		MessageBox("User unknow","Edit Unknow User",MB_ICONWARNING|MB_OK);
		return;
	}
	else {
		CString  pass, name, surname, ip;
		BOOL banned; 
		m_Edit_Pass.GetWindowText(pass);
		m_Edit_Name.GetWindowText(name);
		m_Edit_Surname.GetWindowText(surname);
		m_Edit_Ip.GetWindowText(ip);;
		if (m_Chk_Ban.GetCheck() == CHECK) 
			banned = TRUE;
		else 
			banned = FALSE;

		user->user = name;
		user->ip = ip;
		user->banned = banned;
		user->passwd = pass;
		user->lastname = surname;
	}
}

void CManageUsersDlg::OnSelchangeListUsersOffline() 
{
	// TODO: Add your control notification handler code here	
	CString login;
	m_users_offline_listbox.GetText(m_users_offline_listbox.GetCurSel(), login);
	
	CUserInfo* user = m_document->dbUser->GetUserInfo(login);
	if (user!= NULL) {
		m_Edit_Login.SetWindowText(login);
		m_Edit_Name.SetWindowText(user->user);
		m_Edit_Surname.SetWindowText(user->lastname);
		m_Edit_Pass.SetWindowText(user->passwd);
		if (user->banned == TRUE)
			m_Chk_Ban.SetCheck(CHECK);
		else 
			m_Chk_Ban.SetCheck(UNCHECK);
		m_Edit_Ip.SetWindowText(user->ip);
	}

}

void CManageUsersDlg::OnSelchangeListUsersOnline() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	CString login;
	m_users_online_listbox.GetText(m_users_online_listbox.GetCurSel(), login);
	
	CUserInfo* user = m_document->dbUser->GetUserInfo(login);
	m_Edit_Login.SetWindowText(login);
	m_Edit_Name.SetWindowText(user->user);
	m_Edit_Surname.SetWindowText(user->lastname);
	m_Edit_Pass.SetWindowText(user->passwd);
	if (user->banned == TRUE)
		m_Chk_Ban.SetCheck(CHECK);
	else 
		m_Chk_Ban.SetCheck(UNCHECK);
	m_Edit_Ip.SetWindowText(user->ip);	
}