/********************************************************************
 * Message.cpp                                                      *
 * Classe gerant les messages et leur affichage                     *
 *                                                                  *
 * Nicolas BESSON &  Nicolas MARTIN & Christophe PARIS              *
 * Project Httpd+ - ESSI2 - Sophia Antipolis                        *
 *                                                                  *
 * For more information see the README file                         *
 *                                                                  *
 * January 2001                                                     *  
 ********************************************************************/

#include "Message.h"



using namespace std;



string ltos(long i) {
  int a = i;
  string res = "";
  string c;
  
  while (a > 9) {	  
    res = (char)((a % 10)+'0') + res;
    a /= 10;
  }
  res= (char)(a+'0')+res;  
  return res;
};


//------------------------------------------------------------------------
// Constructeur
//------------------------------------------------------------------------
Message::Message(string mess) : _mess(mess) { };


//------------------------------------------------------------------------
// Affiche un message sur stdin ou dans un fichier de log sous linux en
// mode daemon (l'emplacement du fichier de log est dfini dans
// /etc/syslog.conf et correspond  l'entre local5) en fonction des
// priorits dfinies dans le fichier de configuration.
//------------------------------------------------------------------------
Message::Message(int priority,char* format,...) {
  _priority = priority;
  
 
    // On doit remplacer les %x par les parametres correspondants
    bool havePercent=false;
    va_list par_lst;
    va_start(par_lst, format); 
    char c;
    
    _mess="";
    
    while(*format) {
      if((c=(*format++))=='%') {
        havePercent=true;
      } else if(havePercent) {
        // On vient de lire un %, on peut avoir un parametre a remplacer
        switch(c) {
        case 's':
          // Une chaine de caractre
          _mess+=(char*)va_arg (par_lst, char *);
          break;
        case 'd':
          // Un entier
          _mess+=ltos((int)va_arg(par_lst, int));
          break;
        case 'c':
          // Un caractre
          _mess+=(char)va_arg(par_lst,char);
          break;
        default:
          // le % n'est pas suivi d'un caractre correspondant  un paramtre
          // on ajoute le pourcent et le caractre
          _mess+='%';
          _mess+=c;
          break;
        }
        havePercent=false;
      } else {
        // On a un caractere non prcd d'un %, on le recopie tel quel
        _mess+=c;
      }
    }

      char strCurrentTime[20];
      time_t t=time(NULL);
      struct tm* currentTime=localtime(&t);
      
      strftime(strCurrentTime,20, "%Y-%m-%d %H:%M:%S",currentTime);
      
      cout << strCurrentTime + string(" : ") + _mess;
      
  
  
};

//------------------------------------------------------------------------
// Formatage avec date et heure d'un message dans un ostream.
//------------------------------------------------------------------------
ostream& operator<< (ostream& os, const Message& m) {
  if (m._mess.length() != 0) {
    char strCurrentTime[20];
    time_t t=time(NULL);
    struct tm* currentTime=localtime(&t);
    
    strftime(strCurrentTime,20, "%Y-%m-%d %H:%M:%S",currentTime);
    os << strCurrentTime + string(" : ") + m._mess;
  }
  
  return os;
};

//------------------------------------------------------------------------
// Fin du fichier Message.cpp
//------------------------------------------------------------------------

