/********************************************************************
 * Message.h                                                         *
 * Classe gerant les messages et leur affichage                     *
 *                                                                  *
 * Nicolas BESSON &  Nicolas MARTIN & Christophe PARIS              *
 * Project Httpd+ - ESSI2 - Sophia Antipolis                        *
 *                                                                  *
 * For more information see the README file                         *
 *                                                                  *
 * January 2001                                                     *   
 ********************************************************************/
 
#ifndef _MESSAGE_H_
#define _MESSAGE_H_


// --------------- COMMON include files ---------------
#include <time.h>
#include <stdarg.h> 

#include <iostream>
#include <string>






#define MSGDEBUG   1
#define MSGSYSTEM  2
#define MSGERROR   4
#define MSGREQUEST 8
#define MSGSOCKET 16

#define MSGCONNECT  32
#define MSGSERVER 64

class Message {
public:
  std::string _mess;
  int _priority;  
  
public:
  Message(std::string mess);
  Message(int priority, char* format, ...);

  // Attention l'utilisation du mot cl friend est impossible sous VC6.0 SP<3
  // si l'on dclare "using namespace std" avant
  friend std::ostream& operator<< (std::ostream&, const Message&);
};

#endif
