#ifndef _PROTOCOL_H
#define _PROTOCOL_H
#include <Afxsock.h>

#include <Afxtempl.h>
#include <Afxcoll.h>
#include <iostream>
#define _SIZE_BUFFER 256

class ClientRunner;


using namespace std;


class Parser {

public:
	char token;

	Parser(char mytoken);

	CStringList* extractParams(CString *cs);

};


class ProtocolUnMarshalling {
	
public:
	
	//Invoke the appropriate method
	virtual CString* invoke(CString* request)=0;
	
	//Receive the msg send to the socket (TCP)
	virtual CString* receiveMsg(SOCKET socket)=0;
	
	//Send a msg to the socket
	virtual void sendMsg(SOCKET socket,CString* response)=0;
};

class IradisProtocol : public Protocol {

public:
	
	IradisProtocol(ClientRunner* cr, Parser* pr);

	virtual CString* invoke(CString* request);

	
	//Invocation methods
	
	virtual CString* invokeLOGIN(CStringList* params);

	virtual CString* invokeLOGOUT(CStringList* params);

	virtual CString* invokeWHOIS(CStringList* params);
	
	virtual CString* invokeREGISTER(CStringList* params);


	
	virtual CString* receiveMsg(SOCKET socket);
	
	virtual void sendMsg(SOCKET socket, CString* response);

	ClientRunner *server;
	
	Parser *parser;

};


#endif
