#ifndef _PROTOCOL_SERVER_H
#define _PROTOCOL_SERVER_H

#include <Afxsock.h>

#include "UserInfoManager.h"
#include "DocInfoManager.h"

#include <Afxtempl.h>
#include <Afxcoll.h>
#include <iostream>
#define _SIZE_BUFFER 256

class ServerRunner;
class CTCPDialogThread;


using namespace std;


class Parser {

public:
	char token;

	Parser(char mytoken);

	CStringList* extractParams(CString *cs);

};


class ProtocolServer {
	
public:
	
	virtual CString* createCommand(CStringList* params)=0;
	//Invoke the appropriate method
	virtual CString* invoke(CString* request, CTCPDialogThread* tcpThread)=0;
	
	//Receive the msg send to the socket (TCP)
	virtual CString* receiveMsgTCP(SOCKET socket)=0;
	
	//Send a msg to the socket
	virtual void sendMsgTCP(SOCKET socket,CString* response)=0;

	virtual void sendMsgMULTICAST(CString* buff, char* MulticastGroupIP,int remoteport,SOCKET sock_Listen_MULTICAST)=0;

	
};

class IradisProtocolServer : public ProtocolServer {

public:
	
	IradisProtocolServer(ServerRunner* sr, Parser* pr);

	virtual CString* invoke(CString* request, CTCPDialogThread* tcpThread);

	virtual CString* createCommand(CStringList* params);

	
	//Invocation methods for the server
	
	virtual CString* invokeLOGIN(CStringList* params, CTCPDialogThread* tcpThread);

	virtual CString* invokeLOGOUT(CStringList* params, CTCPDialogThread* tcpThread);

	virtual CString* invokeWHOIS(CStringList* params);
	
	virtual CString* invokeREGISTER(CStringList* params);

	virtual CString* invokeFILEINFO(CStringList* params);

	virtual CString* invokePLAYLIST(CStringList* params);


	//Send and receives methods

	virtual void sendMsgMULTICAST(CString* buff, char* MulticastGroupIP,int remoteport,SOCKET sock_Listen_MULTICAST);
		
	virtual CString* receiveMsgTCP(SOCKET socket);
	
	virtual void sendMsgTCP(SOCKET socket, CString* response);

	
	//members

	ServerRunner *server;
	
	Parser *parser;

};


#endif
