 
#include "stdafx.h"
#include "ProtocolUnMarshalling.h"
#include "Server.h"
#include "Event.h"
#include "ServerListenerManager.h"



/* Commandes
  //On va multicaster la playlist et les users online
  
  // TCP Client -> Server			Server -> Client  
  LOGIN <login> <password> <ip> <port>			

  LOGOUT <login> <ip>

  WHOIS <login>

  REGISTER <login> <pass> <name> <lastname> <ip> <port>

  

*/

#define BASE_OK 200
#define BASE_KO 400


#define CODE_LOGIN 1
#define CODE_LOGOUT 2
#define CODE_WHOIS 3
#define CODE_REGISTER 4
#define CODE_BADPARAMETERS 5
#define CODE_UNKNOWNCOMMAND 6




Parser::Parser(char mytoken):token(mytoken) { }


CStringList* Parser::extractParams(CString *cs){
	CStringList *params = new CStringList();
	int start=0;
	int oldstart=0;
	int index=0;

	while(index >= 0){
		index=cs->Find(token ,start);
		if (index >= 0) params->AddTail(cs->Mid(start,index-start));
		oldstart=start;
		start = index + 1;
	}

	params->AddTail(cs->Mid(oldstart));
	cout << "Protocol::extractParams" << endl;
	return params; 
}




IradisProtocolUnMarshalling::IradisProtocolUnMarshalling(ServerRunner *sr, Parser *pr) : server(sr), parser(pr) { 
}

	
CString* IradisProtocolUnMarshalling::invokeLOGIN(CStringList* params){
     //cout << "Protocol::invokeLOGIN" << endl;
	CString RemoteLogin=params->GetAt(params->FindIndex(1));
	CString RemotePass=params->GetAt(params->FindIndex(2));
	CString RemoteIP=params->GetAt(params->FindIndex(3));
	CString RemotePort=params->GetAt(params->FindIndex(4));

	CUserInfo* user = server->userDB->GetUserInfo(RemoteLogin);
 
	if (user == NULL){
		//The User isn't registered, he must register in order to connect
		//return new CString(BASE_KO + CODE_LOGIN + "");
			
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_LOGIN);
			//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			CString tmp="LOGIN: An unregistered user tried to connect under the login :"+RemoteLogin+"\n";
			server->Notify(new BadCommandEvent(tmp.GetBuffer(0)));
			return res;
	}else{
		//We must check the user (user != null)
		if ( RemotePass == user->passwd && !user->banned && !user->connected ){
				user->ip = RemoteIP;
				user->connected = true;
				user->port = atoi(RemotePort.GetBuffer(0));
				CString * res=new CString();
				res->Format(_T("%d"),BASE_OK + CODE_LOGIN);
				//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
				server->Notify(new UserOnlineEvent(user->login.GetBuffer(0)));
				return res;

		}else{
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_LOGIN);
			//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			CString tmp="LOGIN: An user tried to connect under the login "+RemoteLogin+" but he wasn't allowed to\n";
			server->Notify(new BadCommandEvent(tmp.GetBuffer(0)));
			return res;
		}
	}

};

CString* IradisProtocolUnMarshalling::invokeLOGOUT(CStringList* params){
	
	//cout << "Protocol::invokeLOGOUT" << endl;
	CString RemoteLogin=params->GetAt(params->FindIndex(1));

	CUserInfo* user = server->userDB->GetUserInfo(RemoteLogin);
	
	if (user != NULL){
		//The user exist: change his connected property and send an event
		user->connected = false;
		CString * res=new CString();
		res->Format(_T("%d"),BASE_OK + CODE_LOGOUT);
		server->Notify(new UserOfflineEvent(user->login.GetBuffer(0)));
		return res;

	}else{
		//The user didn't exist in the database ->ERROR
		CString * res=new CString();
		res->Format(_T("%d"),BASE_KO + CODE_LOGOUT);
		server->Notify(new BadCommandEvent("LOGOUT: the user wasn't in the Database"));
		return res;
	}

};


CString* IradisProtocolUnMarshalling::invokeWHOIS(CStringList* params){
	cout << "Protocol::invokeWHOIS" << endl;
	CString RemoteLogin=params->GetAt(params->FindIndex(1));
	
	CUserInfo* user = server->userDB->GetUserInfo(RemoteLogin);
	
	if (user == NULL){
		CString * res=new CString();
		res->Format(_T("%d"),BASE_KO + CODE_WHOIS);
		server->Notify(new BadCommandEvent("WHOIS: the user wasn't in the Database"));
		//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
		return res;
	}else{
		CString userConnected;
		CString userBanned;

		char szTemp[10];
		_itoa(user->port, szTemp, 10);

		if (user->connected) userConnected= "true"; else userConnected= "false";
		if (user->banned) userBanned= "true"; else userBanned= "false";

		CString ret= user->login +  " "  + user->user + " " + user->lastname + " " + userConnected + " " + userBanned + " " + user->ip + " " + szTemp + "";
		return new CString(ret);	
	}

};
	
CString* IradisProtocolUnMarshalling::invokeREGISTER(CStringList* params){
	cout << "Protocol::invokeREGISTER" << endl;
	CString RemoteLogin=params->GetAt(params->FindIndex(1));
	CString RemotePass=params->GetAt(params->FindIndex(2));
	CString RemoteName=params->GetAt(params->FindIndex(3));
	CString RemoteLastName=params->GetAt(params->FindIndex(4));
	CString RemoteIP=params->GetAt(params->FindIndex(5));
	CString RemotePort=params->GetAt(params->FindIndex(6));

	CUserInfo* user = server->userDB->GetUserInfo(RemoteLogin);

	if (  user != NULL){
		
		//The User is already registered 
		CString * res=new CString();
		res->Format(_T("%d"),BASE_KO + CODE_REGISTER);
		//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
		server->Notify(new BadCommandEvent("REGISTER: the user "+RemoteLogin+" already exist in the Database"));
		return res;

	}else{
		
		CUserInfo *ui = new CUserInfo(RemoteLogin, RemotePass, RemoteName,
                     RemoteLastName, false, false, RemoteIP, atoi(RemotePort.GetBuffer(0)));

		server->userDB->RegisterUser(ui);

		CString * res=new CString();
		res->Format(_T("%d"),BASE_OK + CODE_REGISTER);
		//cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
		server->Notify(new NewUserEvent(RemoteLogin.GetBuffer(0)));
		return res;
	}

};



CString* IradisProtocolUnMarshalling::invoke(CString* request) {
	
	cout << "Protocol::invoke" << endl;
	
	CStringList *params =parser->extractParams(request);	
	cout << "number:" << params->GetCount() << endl;
	
	
	for(int i = 0; i < params->GetCount(); i++){
		POSITION pos=params->FindIndex(i);
		cout << "param: " << (params->GetAt(pos)).GetBuffer(0) << "..." << endl;
	}
	
	


	CString commande=params->GetHead();
	

	if (commande == "LOGIN"){
			cout << "Protocol::ON rentre dans login" << endl;
		//We need to ckeck the number of parameters
		if (params->GetCount() == 5) return invokeLOGIN(params);
		else { 
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_BADPARAMETERS);
			cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			return res;
		}
	}else if (commande == "LOGOUT"){
		//We need to ckeck the number of parameters
		if (params->GetCount() == 3) return invokeLOGOUT(params);
		else { 
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_BADPARAMETERS);
			cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			return res;
		}
	}else if (commande == "WHOIS"){
		//We need to ckeck the number of parameters
		if (params->GetCount() == 2) return invokeWHOIS(params);
		else{ 
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_BADPARAMETERS);
			cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			return res;
		}
	}else if (commande == "REGISTER"){
		//We need to ckeck the number of parameters
		if (params->GetCount() == 7) return invokeREGISTER(params);
		else{ 
			CString * res=new CString();
			res->Format(_T("%d"),BASE_KO + CODE_BADPARAMETERS);
			cout << "protocol::je vais sender " << res->GetBuffer(0) << endl;
			return res;
		}
	}else {
		cout << "Protocol::UNKNOWCOMMAND" << endl;
		CString * tmp=new CString();
		tmp->Format(_T("%d"),BASE_KO + CODE_UNKNOWNCOMMAND);
		cout << "protocol::je vais sender " << tmp->GetBuffer(0) << endl;
		return tmp;
	}

}
	

CString* IradisProtocolUnMarshalling::receiveMsg(SOCKET socket){
	char *buffer=new char[_SIZE_BUFFER];
	int size_recv = recv(socket,buffer,_SIZE_BUFFER-1,0);
	if( size_recv == SOCKET_ERROR)
	{
		return NULL;
	}
	buffer[size_recv]='\0';
	return new CString(buffer);
}


void IradisProtocolUnMarshalling::sendMsg(SOCKET socket, CString* response){
	send(socket,*response, response->GetLength(), 0);
}


