#ifndef _SERVER_H
#define _SERVER_H

#include <Afxsock.h>
#include <Afxtempl.h>
#include <Afxcoll.h>
#include "Message.h"
#include "Utils.h"
#include "ServerListenerManager.h"
#include "ProtocolServer.h"

#include <iostream>

#include "DocInfoManager.h"
#include "UserInfoManager.h"
#include "FcastSenderThread.h"
#include "PlayList.h"


using namespace std;

/* TODO & bugs

- Quand on ajoute un document vrifier qu'il fait bien partie d'un sous rpertoire.
- Il ne faut pas bouger le document que l'on envoie
- delete packet dans multicast
- Ajouter une commande upload, (UPLOAD client_port filename description ...)
    - crer un nouveau thread dans l'invokeUPLOAD, ce thread
      se connect sur le port du client et reoit le fichier

*/

///////////////////////////////////////////////////////////
///   Server Runner
///////////////////////////////////////////////////////////

class ServerRunner : public ServerListenerManager{
	
	public:
		ServerRunner(DocInfoManager* dbdoc, UserInfoManager* dbuser);

		~ServerRunner();

		void Start(int TCP_port,int MULTICAST_port, CString MULTICAST_ip, int RemoteMULTICAST_port,
			CString FcastIP, int FcastPort, int FcastRound, int FcastRate);

		void Close(); 

		void Close(char *ip);

		void SendMULTICAST(CStringList* params);

		void SendPlaylist();
		void SendFcastInfo();
		
		//Methods that uses the Database API
		CStringList* ListUsersOnline();

		CStringList* ListUsersOffline();

		CStringList* getPlayList();

	
	public:
		DocInfoManager	*docDB;
		UserInfoManager	*userDB;
		CPlayList		*playlist;
		ProtocolServer * proto; 
		CList<CWinThread *,CWinThread *> Threads;

		CString FcastIP;
		int FcastPort;
    FcastSenderThread* fcastSndThread;
	HANDLE SendMultiSem; 
	CMutex* PlaylistMtx;		
};
///////////////////////////////////////////////////////////
/// CTCP Runner  
///////////////////////////////////////////////////////////


class CTCPRunner:public CWinThread {
	
DECLARE_DYNCREATE(CTCPRunner)

	protected:

		CTCPRunner();

		virtual ~CTCPRunner();
	
	public:
	

		void InitTCP();

		void Close();

		virtual int Run();
	
		virtual BOOL InitInstance();

		virtual int ExitInstance();

	// variables
	protected:
		

	public:
		ServerRunner * server;
		int				listenport;
		SOCKET			sock_Listen_TCP;

		CList<CWinThread *,CWinThread *> Threads;

};

///////////////////////////////////////////////////////////
/// CMULTICAST Runner  
///////////////////////////////////////////////////////////

class CMULTICASTRunner:public CWinThread {
	
DECLARE_DYNCREATE(CMULTICASTRunner)

	protected:

		CMULTICASTRunner();

		virtual ~CMULTICASTRunner();
	
	public:

		void InitMULTICAST();

		void Close();
	
		virtual BOOL InitInstance();

		virtual int ExitInstance();

		virtual int Run();

		void Send(char* buff, int size, char *group);

		

	public:
		ServerRunner *  server;
		BOOL			quit;		
		int				listenport;
		int				remoteport;
		SOCKET			sock_Listen_MULTICAST;
		CStringList*    params;
		CString ip;

};

///////////////////////////////////////////////////////////
/// CServer TCP Dialog
///////////////////////////////////////////////////////////

class CTCPDialogThread:public CWinThread {

DECLARE_DYNCREATE(CTCPDialogThread)
	
	protected:

		CTCPDialogThread();

		virtual ~CTCPDialogThread();
	
	public:

		void Close();
	
		virtual BOOL InitInstance();

		virtual int ExitInstance();

		virtual int Run();
		
	protected:
		
	
	public:
		CString* Receive();
		ServerRunner * server;
		SOCKET cliSock;
		SOCKADDR_IN addr_Client;
		BOOL quit;
		CString login;
		

};

#endif