// ServerAudioDoc.cpp : implementation of the CServerAudioDoc class
//

#include "stdafx.h"
#include "ServerAudio.h"

#include "ServerAudioDoc.h"
#include "ManagePlayList.h"
#include "ServerAudioView.h"
#include "ManageUsersDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerAudioDoc

IMPLEMENT_DYNCREATE(CServerAudioDoc, CDocument)

BEGIN_MESSAGE_MAP(CServerAudioDoc, CDocument)
	//{{AFX_MSG_MAP(CServerAudioDoc)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_SEND_MAIL, OnFileSendMail)
	ON_UPDATE_COMMAND_UI(ID_FILE_SEND_MAIL, OnUpdateFileSendMail)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerAudioDoc construction/destruction

CServerAudioDoc::CServerAudioDoc(): server_ini(".\\server.ini"), server()
{
	TCHAR cwdBuffer[MAX_PATH];
	DWORD LenCurDir = GetCurrentDirectory (MAX_PATH, cwdBuffer);
	CString m_path; m_path.Format(_T("%s\\server.ini"), cwdBuffer);
	server_ini.SetFile(m_path);

	
	// TODO: add one-time construction code here
	serverRunning = FALSE;
	//server=new FakeServer();
	
	
	//INIT USERS DATABASE

	
	dbUser=new UserInfoManager(server_ini.m_clientDb);
	dbDoc=new DocInfoManager(server_ini.m_docDb);
	//dbUser->GetList(&m_users_offline_list,false);
	//dbUser->GetList(&m_users_online_list,true);
	
	

	//SERVER INIT
	server = new ServerRunner(dbDoc,dbUser);
	playlist=server->playlist;
	server->AddListener(this);
	
	
	//
	cManPlayList=NULL;
	cManageUsersDlg=NULL;

	/*
	CDocInfo cdi("essai.txt","bob","upload","txt",FALSE,TRUE,"Mon fichier a moi");
	playlist->Enqueue(cdi);
	CDocInfo cdi1("mess.txt","billounet","upload\\billounet","txt",FALSE,TRUE,"Un super fichier texte");
	playlist->Enqueue(cdi1);
	CDocInfo cdi2("ess.zip","merdalor","upload\\merdalor","zip",FALSE,TRUE,"Son fichier a lui");
	playlist->Enqueue(cdi2);
	CDocInfo cdi3("autoexec.bat","supervisor","upload","bat",FALSE,TRUE,"Mon fichier de demarrage");
	playlist->Enqueue(cdi3);
*/
	
	
	//server->test();
}

CServerAudioDoc::~CServerAudioDoc()
{
}

BOOL CServerAudioDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CServerAudioDoc serialization

void CServerAudioDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar << server_ini.m_tcpPort;
		ar << server_ini.m_udpPort;
		ar << server_ini.m_udpIP;
	}
	else
	{
		// TODO: add loading code here
		ar >> server_ini.m_tcpPort;
		ar >> server_ini.m_udpPort;
		ar >> server_ini.m_udpIP;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CServerAudioDoc diagnostics

#ifdef _DEBUG
void CServerAudioDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CServerAudioDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServerAudioDoc commands

int CServerAudioDoc::GetUDPMulticastPort()
{
	return server_ini.m_udpPort;
}

int CServerAudioDoc::GetTCPPort()
{
	return server_ini.m_tcpPort;
}

CString CServerAudioDoc::GetUDPMulticastIP()
{
	//MessageBox(NULL,server_ini.m_udpIP,"",MB_OK);
	return server_ini.m_udpIP;
}

BOOL CServerAudioDoc::StartServer()
{
	// Ici, le Code qui va connecter le server
	 
	//GetUDPMulticastIP(); 

	
	server->Start(GetTCPPort(), GetUDPMulticastPort(), GetUDPMulticastIP(), GetUDPMulticastPort(),
		GetFcastIP(), GetFcastPort(), GetFcastRound(), GetFcastRate());	
	
	serverRunning = TRUE;

	dbUser->GetList(&m_users_offline_list, false);
	dbUser->GetList(&m_users_online_list, true);
	

	//INIT DOC DATABASE


	// ici, au lieu de , se connecter au Server et demander la liste des onlines et offline.
//	m_users_online_list.AddTail(CString("toyas2"));
//	m_users_online_list.AddTail(CString("canet2"));
//	m_users_online_list.AddTail(CString("besson2"));
//	m_users_offline_list.AddTail(CString("martin3"));
//	m_users_offline_list.AddTail(CString("titi"));
	return TRUE;
}

BOOL CServerAudioDoc::StopServer()
{
	// Ici le code qui deconnecterq le server
	// retourne true si pas d'erreur
	m_users_offline_list.RemoveAll();
	m_users_online_list.RemoveAll();
	// save database, to disk
	dbUser->setAllOffline();
	dbUser->Flush();
	dbDoc->Flush();
	server->fcastSndThread->SuspendThread();
	server->Close();
	serverRunning = FALSE;
	return TRUE;
}

BOOL CServerAudioDoc::ServerIsRunning()
{
	return serverRunning;
}

BOOL CServerAudioDoc::CreateUser(CString username)
{
	m_users_offline_list.AddTail(username);
	return TRUE;
}

BOOL CServerAudioDoc::DeleteUser(CString login)
{
	POSITION pos;
	if(pos = m_users_offline_list.Find(login)){
		m_users_offline_list.RemoveAt(pos);
		return TRUE;
	} else 
	if (pos = m_users_online_list.Find(login)){
		m_users_online_list.RemoveAt(pos);
		return TRUE;
	}
	return false;
}

void CServerAudioDoc::SetDocumentPath(CString path)
{
	server_ini.m_docPath = path;
}

CString& CServerAudioDoc::GetDocumentPath()
{
	return server_ini.m_docPath;
}

void CServerAudioDoc::SetTCPPort(int port)
{
	server_ini.m_tcpPort = port;
}

void CServerAudioDoc::SetUDPMulticastPort(int port)
{
	server_ini.m_udpPort = port;
}

void CServerAudioDoc::SetUDPMulticastIP(CString group)
{
	server_ini.m_udpIP = group;
}

void CServerAudioDoc::SetDocumentDbFile(CString dbFile)
{
	server_ini.m_docDb = dbFile;
}

void CServerAudioDoc::SetUserDbFile(CString dbFile)
{
	server_ini.m_clientDb = dbFile;
}

CString& CServerAudioDoc::GetDocumentDbFile()
{
	return server_ini.m_docDb;
}

CString& CServerAudioDoc::GetUserDbFile()
{
	return server_ini.m_clientDb;
}

void CServerAudioDoc::SetFcastIP(CString ip)
{
	server_ini.m_FcastIP = ip;
}


void CServerAudioDoc::SetFcastPort(int port)
{
	server_ini.m_FcastPort = port;
}

void CServerAudioDoc::SetFcastRound(int round)
{
	server_ini.m_FcastRound = round;
}

void CServerAudioDoc::SetFcastRate(int rate)
{
	server_ini.m_FcastRate = rate;
}

CString CServerAudioDoc::GetFcastIP()
{
	return server_ini.m_FcastIP;
}

int CServerAudioDoc::GetFcastPort()
{
	return server_ini.m_FcastPort;
}

int CServerAudioDoc::GetFcastRate()
{
	return server_ini.m_FcastRate;
}


int CServerAudioDoc::GetFcastRound()
{
	return server_ini.m_FcastRound;
}


void CServerAudioDoc::SaveConfig()
{
	server_ini.Save();
}

CPlayList* CServerAudioDoc::GetPlayList()
{
	return playlist;
}



void CServerAudioDoc::OnNewEvent(Event* e){
	CDocInfo cdi("Nouveau","newtest","upload","txt",FALSE,TRUE,"Ajout a partir d un evenement");
	//POSITION pos;
	CString temp;

	switch (e->getMessageCode()){
		/*	CPlayList();
	virtual ~CPlayList();
	CDocInfo GetHead();
	void Enqueue(CDocInfo doc);
	int ChangePriority(int elem, int incr);
	CDocInfo GetElementAt(int pos);
	BOOL RemoveElementAt(int pos);
	void RemoveAll();
	int Size();*/

	case USER_NEW :
		//A NEW USER WAS ADDED TO THE DATABASE
    cServerAudioView->AddLineLog( CString("A new client was added to the database : ") + e->getParam(0) );
		m_users_offline_list.RemoveAll();
		m_users_online_list.RemoveAll();
		dbUser->GetList(&m_users_offline_list,false);
		dbUser->GetList(&m_users_online_list,true);
		if(cManageUsersDlg!=NULL){
			cManageUsersDlg->NbRefresh();
		}
		
		break;
	case USER_DEL :
		//ERASE THE USER FROM THE LIST
    cServerAudioView->AddLineLog( CString("A client was removed from the database : ") + e->getParam(0) );
		m_users_offline_list.RemoveAll();
		m_users_online_list.RemoveAll();
		dbUser->GetList(&m_users_offline_list,false);
		dbUser->GetList(&m_users_online_list,true);
		if(cManageUsersDlg!=NULL){
			cManageUsersDlg->NbRefresh();
		}
		break;
	case USER_ONLINE :
		//SET THE USER ONLINE
    cServerAudioView->AddLineLog( CString("New client logged : ") + e->getParam(0) );
		m_users_offline_list.RemoveAll();
		m_users_online_list.RemoveAll();
		dbUser->GetList(&m_users_offline_list,false);
		dbUser->GetList(&m_users_online_list,true);
		if(cManageUsersDlg!=NULL){
			cManageUsersDlg->NbRefresh();
		}
		
		
		
		break;
	case USER_OFFLINE :
		//SET THE USER OFFLINE
    cServerAudioView->AddLineLog( CString(e->getParam(0)) + " has logged out." );
		m_users_offline_list.RemoveAll();
		m_users_online_list.RemoveAll();
		dbUser->GetList(&m_users_offline_list,false);
		dbUser->GetList(&m_users_online_list,true);
		
		if(cManageUsersDlg!=NULL){
			cManageUsersDlg->NbRefresh();
		}
		
		break;
		
	case DOC_NEW :
		//ADD A NEW DOC TO THE PLAYLIST
		//MessageBox(NULL,cdi.getKey(),"erreur",MB_OK);
    cServerAudioView->AddLineLog( "A new file was addded to the playlist" );
		playlist->Enqueue(cdi);
		if(cManPlayList!=NULL){
			cManPlayList->Fill();
		}
		
		break;
	
	/*case DOC_DEL :

		playlist.RemoveElement(CString(e->getParam(0)));

		break;
	*/
	/*case DOC_START :
		break;
	
	case DOC_STOP :
		break;
	*/	
	case BAD_COMMAND :
    cServerAudioView->AddLineLog( e->getParam(0) );
		break;
	case GOOD_COMMAND :
    cServerAudioView->AddLineLog( e->getParam(0) );
		break;
	case UPDATE_PLAYLIST_EVENT:
		if(cManPlayList != NULL){
			cManPlayList->Fill();
		}
		if( serverRunning )
			server->SendPlaylist();
		cServerAudioView->AddLineLog( "The playlist has been updated." );
		break;
	default :
		//MessageBox(NULL,"Bad Event","bad Event",MB_OK);
		//ERREUR IMPOSSIBLE!
    cServerAudioView->AddLineLog( "Unknow Event" );
		break;
	}
	// delete the event
	delete e;
}

