// ServerAudioDoc.h : interface of the CServerAudioDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVERAUDIODOC_H__5DE67377_9C00_45E2_9B8A_8D2D92D94662__INCLUDED_)
#define AFX_SERVERAUDIODOC_H__5DE67377_9C00_45E2_9B8A_8D2D92D94662__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "ServerInit.h"
#include "PlayList.h"
#include "Event.h"
#include "Server.h"
#include "ServerListenerManager.h"

//#include "ManagePlayList.h"
class CManagePlayList;
class CServerAudioView;
class CManageUsersDlg;

//#include "ServerAudioView.h"

class CServerAudioDoc : public CDocument, ServerListener
{
protected: // create from serialization only
	CServerAudioDoc();
	DECLARE_DYNCREATE(CServerAudioDoc)

// Attributes

//The components wich have to be modified when an event is received
public:
	
 //GUI Members
 CManagePlayList * cManPlayList;
 CServerAudioView * cServerAudioView;
 CManageUsersDlg * cManageUsersDlg;

//server + Database
 ServerRunner* server;
 UserInfoManager* dbUser;
 DocInfoManager* dbDoc;

protected:
/*	CString udpMulticastIP;
	int udpMulticastPORT;
	int tcpPORT;*/
	CServerInit server_ini;
	CPlayList * playlist;
 

	//A GUI pointer (to update the GUI when receiving a new Event).
	

// Operations
public:


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServerAudioDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL ServerIsRunning();
	BOOL StopServer();
	BOOL StartServer();
	
	CString GetUDPMulticastIP();
	int GetTCPPort();
	int GetUDPMulticastPort();

	virtual ~CServerAudioDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	CPlayList* GetPlayList();
	void SaveConfig();
	CString& GetUserDbFile();
	CString& GetDocumentDbFile();
	void SetUserDbFile(CString dbFile);
	void SetDocumentDbFile(CString dbFile);
	void SetUDPMulticastIP(CString group);
	void SetUDPMulticastPort(int port);
	void SetTCPPort(int port);
	CString& GetDocumentPath();
	void SetDocumentPath(CString path);
	BOOL DeleteUser(CString login);
	BOOL CreateUser(CString username);
	CStringList m_users_offline_list;
	CStringList m_users_online_list;

	
protected:
	BOOL serverRunning;
	//{{AFX_MSG(CServerAudioDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

//to implement the ServerListener Interface
public:
	int GetFcastRound();
	int GetFcastRate();
	int GetFcastPort();
	CString GetFcastIP();
	void SetFcastRate(int rate);
	void SetFcastRound(int round);
	void SetFcastPort(int port);
	void SetFcastIP(CString ip);
    virtual void OnNewEvent(Event* e) ;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVERAUDIODOC_H__5DE67377_9C00_45E2_9B8A_8D2D92D94662__INCLUDED_)
