// ServerAudioView.cpp : implementation of the CServerAudioView class
//

#include "stdafx.h"
#include "ServerAudio.h"

#include "ServerAudioDoc.h"
#include "ServerAudioView.h"
#include "ManageDocsDlg.h"
#include "ManageUsersDlg.h"
#include "ManagePlayList.h"
#include <shlobj.h> // To browse directory

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerAudioView

IMPLEMENT_DYNCREATE(CServerAudioView, CFormView)

BEGIN_MESSAGE_MAP(CServerAudioView, CFormView)
	//{{AFX_MSG_MAP(CServerAudioView)
	ON_BN_CLICKED(IDC_MANAGE_USERS, OnManageUsers)
	ON_BN_CLICKED(IDC_MANAGE_DOCUMENTS, OnManageDocuments)
	ON_BN_CLICKED(IDC_SERVER_START, OnServerStart)
	ON_BN_CLICKED(IDC_SERVER_STOP, OnServerStop)
	ON_BN_CLICKED(IDC_BTN_BROWSE_DB_DOC, OnBtnBrowseDbDoc)
	ON_BN_CLICKED(IDC_BTN_BROWSE_PATH, OnBtnBrowsePath)
	ON_BN_CLICKED(IDC_BTN_BROWSE_DB_USER, OnBtnBrowseDbUser)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_BN_CLICKED(IDC_BTN_CLEAR_LOG, OnBtnClearLog)
	ON_BN_CLICKED(IDC_BTN_PLAYLIST, OnBtnPlaylist)
	ON_EN_CHANGE(IDC_TCP_PORT, OnChangeTcpPort)
	ON_EN_CHANGE(IDC_UDP_PORT, OnChangeUdpPort)
	ON_EN_CHANGE(IDC_IP_UDP, OnChangeIpUdp)
	ON_EN_CHANGE(IDC_DOCUMENT_DB, OnChangeDocumentDb)
	ON_EN_CHANGE(IDC_DOCUMENT_PATH, OnChangeDocumentPath)
	ON_EN_CHANGE(IDC_USER_DB, OnChangeUserDb)
	ON_EN_CHANGE(IDC_EDIT_FCAST_IP, OnChangeEditFcastIp)
	ON_EN_CHANGE(IDC_EDIT_FCAST_PORT, OnChangeEditFcastPort)
	ON_EN_CHANGE(IDC_EDIT_FCAST_RATE, OnChangeEditFcastRate)
	ON_EN_CHANGE(IDC_EDIT_FCAST_ROUND, OnChangeEditFcastRound)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerAudioView construction/destruction

CServerAudioView::CServerAudioView()
	: CFormView(CServerAudioView::IDD)
{
	//{{AFX_DATA_INIT(CServerAudioView)
	m_Tcp_Port = 0;
	m_Udp_Port = 0;
	m_Udp_Multicast_ip = _T("");
	m_document_path = _T("");
	m_document_db_file = _T("");
	m_user_db_file = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	
}

CServerAudioView::~CServerAudioView()
{
}

void CServerAudioView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerAudioView)
	DDX_Control(pDX, IDC_EDIT_FCAST_ROUND, m_edit_fcast_round_o);
	DDX_Control(pDX, IDC_EDIT_FCAST_RATE, m_edit_fcast_rate_o);
	DDX_Control(pDX, IDC_EDIT_FCAST_PORT, m_edit_fcast_port_o);
	DDX_Control(pDX, IDC_EDIT_FCAST_IP, m_edit_fcast_ip_o);
	DDX_Control(pDX, IDC_BTN_SAVE, m_Btn_SaveParams);
	DDX_Control(pDX, IDC_BTN_PLAYLIST, m_Btn_PlayList);
	DDX_Control(pDX, IDC_BTN_CLEAR_LOG, m_Btn_Log_Clear);
	DDX_Control(pDX, IDC_TXT_LOG, m_Log_o);
	DDX_Control(pDX, IDC_USER_DB, m_user_db_file_o);
	DDX_Control(pDX, IDC_DOCUMENT_DB, m_document_db_file_o);
	DDX_Control(pDX, IDC_BTN_BROWSE_PATH, m_Btn_Browse);
	DDX_Control(pDX, IDC_BTN_BROWSE_DB_USER, m_Btn_Browse_Db_User);
	DDX_Control(pDX, IDC_BTN_BROWSE_DB_DOC, m_Btn_Browse_Db_Doc);
	DDX_Control(pDX, IDC_DOCUMENT_PATH, m_document_path_o);
	DDX_Control(pDX, IDC_IP_UDP, m_Udp_Multicast_ip_o);
	DDX_Control(pDX, IDC_UDP_PORT, m_Udp_Port_o);
	DDX_Control(pDX, IDC_TCP_PORT, m_Tcp_Port_o);
	DDX_Control(pDX, IDC_MANAGE_USERS, m_manage_users_btn);
	DDX_Control(pDX, IDC_MANAGE_DOCUMENTS, m_manage_documents_btn);
	DDX_Control(pDX, IDC_SERVER_START, m_server_start);
	DDX_Control(pDX, IDC_SERVER_STOP, m_server_stop);
	DDX_Text(pDX, IDC_TCP_PORT, m_Tcp_Port);
	DDX_Text(pDX, IDC_UDP_PORT, m_Udp_Port);
	DDX_Text(pDX, IDC_IP_UDP, m_Udp_Multicast_ip);
	DDV_MaxChars(pDX, m_Udp_Multicast_ip, 15);
	DDX_Text(pDX, IDC_DOCUMENT_PATH, m_document_path);
	DDX_Text(pDX, IDC_DOCUMENT_DB, m_document_db_file);
	DDX_Text(pDX, IDC_USER_DB, m_user_db_file);
	//}}AFX_DATA_MAP
}

BOOL CServerAudioView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CServerAudioView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	// Initialise dialog items
	CString temp;
	temp.Format(_T("%d"),GetDocument ()->GetTCPPort ());
	m_Tcp_Port_o.SetWindowText(temp);

	temp.Format(_T("%d"), GetDocument ()->GetUDPMulticastPort ());
	m_Udp_Port_o.SetWindowText(temp);

	m_Udp_Multicast_ip_o.SetWindowText(GetDocument ()->GetUDPMulticastIP ());
	m_document_path_o.SetWindowText(GetDocument ()->GetDocumentPath ());
	m_document_db_file_o.SetWindowText(GetDocument ()->GetDocumentDbFile());
	m_user_db_file_o.SetWindowText(GetDocument ()->GetUserDbFile());
	m_edit_fcast_ip_o.SetWindowText(GetDocument ()->GetFcastIP());
	
	temp.Format(_T("%d"), GetDocument ()->GetFcastPort());
	m_edit_fcast_port_o.SetWindowText(temp);

	temp.Format(_T("%d"), GetDocument ()->GetFcastRound());
	m_edit_fcast_round_o.SetWindowText(temp);

	temp.Format(_T("%d"), GetDocument ()->GetFcastRate());
	m_edit_fcast_rate_o.SetWindowText(temp);

  /* An icon on a button  
  CWinApp* pApp = AfxGetApp();
  HICON m_hIcon = pApp->LoadIcon( IDI_ICON1 );
  ASSERT(m_hIcon);
  m_Btn_Log_Clear.SetIcon( m_hIcon ); */

	GetDocument()->cServerAudioView=this;

}

/////////////////////////////////////////////////////////////////////////////
// CServerAudioView printing

BOOL CServerAudioView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CServerAudioView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CServerAudioView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CServerAudioView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CServerAudioView diagnostics

#ifdef _DEBUG
void CServerAudioView::AssertValid() const
{
	CFormView::AssertValid();
}

void CServerAudioView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CServerAudioDoc* CServerAudioView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CServerAudioDoc)));
	return (CServerAudioDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServerAudioView message handlers

void CServerAudioView::OnManageUsers() 
{
	// Fonction excut sur click du bouton 'Manage Users' ou commande 'Users...'
	GetDocument()->cManageUsersDlg = new CManageUsersDlg(NULL, GetDocument());
	GetDocument()->cManageUsersDlg->DoModal();
	delete GetDocument()->cManageUsersDlg;
	GetDocument()->cManageUsersDlg = NULL;

	// mise  jour des variables
	
}

void CServerAudioView::OnManageDocuments() 
{
	//	 Fonction excut sur clicl bouton "Manage docs" ou commande "Documents..."
	CManageDocsDlg dialog(NULL,GetDocument (), DIALOG_MANAGE);	
	dialog.DoModal();
	
}

void CServerAudioView::OnServerStart() 
{
  UpdateData(TRUE);

  DWORD fa; // file attributes
  int lastBackSlashPos;

  // Check path of database file before starting server  
  lastBackSlashPos = m_document_db_file.ReverseFind( '\\' );
  fa = GetFileAttributes ( m_document_db_file.Left(lastBackSlashPos) );
  if( !( fa != 0xFFFFFFFF && (fa & FILE_ATTRIBUTE_DIRECTORY)) ) {
    MessageBox("Document database path is not valide !","Error",MB_OK | MB_ICONERROR);
    m_document_db_file_o.SetFocus();
    return;
  }
  
  fa = GetFileAttributes(m_document_path);
  if( !( fa != 0xFFFFFFFF && (fa & FILE_ATTRIBUTE_DIRECTORY)) ) {
    MessageBox("Document path is not valide !","Error",MB_OK | MB_ICONERROR);
    return;
  }

  lastBackSlashPos = m_user_db_file.ReverseFind( '\\' );
  fa = GetFileAttributes ( m_user_db_file.Left(lastBackSlashPos) );
  if( !( fa != 0xFFFFFFFF && (fa & FILE_ATTRIBUTE_DIRECTORY)) ) {
    MessageBox("User database path is not valide !","Error",MB_OK | MB_ICONERROR);
    return;
  }

	// action du Bouton Server Start ou commande du mme nom
	if(GetDocument()->StartServer()) {
		// affiche que le serveur est demarr
		m_server_start.EnableWindow(FALSE);
		m_server_stop.EnableWindow(TRUE);
		m_manage_users_btn.EnableWindow(TRUE);
		m_manage_documents_btn.EnableWindow(TRUE);
		m_Tcp_Port_o.EnableWindow(FALSE);
		m_Udp_Multicast_ip_o.EnableWindow(FALSE);
		m_Udp_Port_o.EnableWindow(FALSE);
		m_Btn_Browse.EnableWindow(FALSE);
		m_Btn_Browse_Db_Doc.EnableWindow(FALSE); 
		m_Btn_Browse_Db_User.EnableWindow(FALSE); 
		m_Btn_Log_Clear.EnableWindow(TRUE);
		m_Log_o.SetWindowText (""); // clear Log
		m_Btn_SaveParams.EnableWindow(FALSE);
		m_edit_fcast_ip_o.EnableWindow(FALSE);
		m_edit_fcast_port_o.EnableWindow(FALSE);
		m_edit_fcast_rate_o.EnableWindow(FALSE);
		m_edit_fcast_round_o.EnableWindow(FALSE);

    AddLineLog("Server started.");
		//AfxMessageBox("Server started.");	
	} else {		
    AddLineLog("Server start error.");
	}
	
	
}

void CServerAudioView::OnServerStop() 
{
	// action du Bouton Server Stop ou commande du mme nom
	if(GetDocument()->StopServer()) {
		// affiche que le serveur est demarr		
		m_server_stop.EnableWindow(FALSE);
		m_manage_users_btn.EnableWindow(FALSE);
		m_manage_documents_btn.EnableWindow(FALSE);
		m_server_start.EnableWindow(TRUE);
		m_Tcp_Port_o.EnableWindow(TRUE);
		m_Udp_Multicast_ip_o.EnableWindow(TRUE);
		m_Udp_Port_o.EnableWindow(TRUE);
		m_Btn_Browse.EnableWindow(TRUE);
		m_Btn_Browse_Db_Doc.EnableWindow(TRUE); 
		m_Btn_Browse_Db_User.EnableWindow(TRUE); 
		m_Btn_Log_Clear.EnableWindow(FALSE);
		m_Btn_SaveParams.EnableWindow(TRUE);
		m_edit_fcast_ip_o.EnableWindow(TRUE);
		m_edit_fcast_port_o.EnableWindow(TRUE);
		m_edit_fcast_rate_o.EnableWindow(TRUE);
		m_edit_fcast_round_o.EnableWindow(TRUE);

//		GetDocument()->
		
    AddLineLog("Server stopped.");
	} else {
		AddLineLog("Server Stop error.");
	}

	
}


void CServerAudioView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	CFormView::CalcWindowRect(lpClientRect, nAdjustType);
}


void CServerAudioView::OnBtnBrowse() 
{

}

void CServerAudioView::OnBtnBrowsePath() 
{
	// TODO: Add your control notification handler code here
	BROWSEINFO info;
    LPITEMIDLIST lpitem;
    LPMALLOC g_pMalloc;

    SHGetMalloc(&g_pMalloc);

    // Used for storing the folders pathname
    char folder[MAX_PATH];

    //Initialize the BROWSEINFO structure
    info.hwndOwner=m_hWnd;
    info.pidlRoot=NULL;
    //Store selected item here
    info.pszDisplayName=folder;
    //Display this text
    info.lpszTitle="Select a folder to put recorded files : ";
    //Only directories are valid selctions
    info.ulFlags=BIF_RETURNONLYFSDIRS;
    info.lpfn=NULL;
    info.iImage=0;

    // Get the ITEMIDLIST object
    // The return ptr must be freed manually, see later
    if((lpitem=SHBrowseForFolder(&info))==NULL)
      return; // Erreur

    // Convert the ITEMIDLIST to the complete folder name
    if(!SHGetPathFromIDList(lpitem,folder))
      return; // Erreur
		
	CString temp(folder);
	m_document_path_o.SetWindowText(temp);
	GetDocument()->SetDocumentPath(temp);

    // Free the lpitem object
    g_pMalloc->Free(lpitem);
}

void CServerAudioView::OnBtnBrowseDbUser() 
{
	// TODO: Add your control notification handler code here
	CFileDialog cfd(FALSE, ".dat","ClientDB.dat",OFN_HIDEREADONLY,"Client Database (*.dat)|*.dat|All Files (*.*)|*.*||",NULL);

	if (cfd.DoModal () == IDOK) {
		//CFile f(cfd.GetPathName (), CFile::modeRead);

		m_user_db_file_o.SetWindowText(cfd.GetPathName ());
		GetDocument ()->SetUserDbFile(cfd.GetPathName ());
	}	
}

void CServerAudioView::OnBtnBrowseDbDoc() 
{
	// TODO: Add your control notification handler code here
	CFileDialog cfd(FALSE, ".dat","DocumentDB.dat",OFN_HIDEREADONLY,"Document Database (*.dat)|*.dat|All Files (*.*)|*.*||",NULL);
	
	if (cfd.DoModal () == IDOK) {
		//CFile f(cfd.GetPathName (), CFile::modeRead);

		m_document_db_file_o.SetWindowText(cfd.GetPathName ());
		GetDocument ()->SetDocumentDbFile(cfd.GetPathName ());
	}
}

void CServerAudioView::OnBtnSave() 
{
	// TODO: Add your control notification handler code here
	GetDocument ()->SaveConfig();
}


void CServerAudioView::OnBtnClearLog() 
{
	// TODO: Add your control notification handler code here
	m_Log_o.SetWindowText ("");
}

void CServerAudioView::OnBtnPlaylist() 
{
	// TODO: Add your control notification handler code here
	CManagePlayList cmpl(NULL, GetDocument ());
	cmpl.DoModal();
}

void CServerAudioView::OnChangeTcpPort() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_Tcp_Port_o.GetWindowText(valt);
	int vali = atoi(valt.GetBuffer(0));
	GetDocument ()->SetTCPPort(vali);
}

void CServerAudioView::OnChangeUdpPort() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	//
	CString valt;
	m_Udp_Port_o.GetWindowText(valt);
	int vali = atoi(valt.GetBuffer(0));
	GetDocument ()->SetUDPMulticastPort(vali);

}

void CServerAudioView::OnChangeIpUdp() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_Udp_Multicast_ip_o.GetWindowText(valt);
	GetDocument ()->SetUDPMulticastIP(valt);
}

void CServerAudioView::OnChangeDocumentDb() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_document_db_file_o.GetWindowText(valt);
	GetDocument ()->SetDocumentDbFile(valt);
}

void CServerAudioView::OnChangeDocumentPath() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_document_path_o.GetWindowText(valt);
	GetDocument ()->SetDocumentPath(valt);
}

void CServerAudioView::OnChangeUserDb() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_user_db_file_o.GetWindowText(valt);
	GetDocument ()->SetUserDbFile(valt);
}

void CServerAudioView::AddLineLog(CString str) {
  
  CString strBuffer;    // current contents of edit control

  // Append string
  m_Log_o.GetWindowText(strBuffer);

  strBuffer += str;
  strBuffer += "\r\n";

  m_Log_o.SetWindowText (strBuffer);

  // Scroll the edit control
  m_Log_o.LineScroll( m_Log_o.GetLineCount()-1 );
}

void CServerAudioView::OnChangeEditFcastIp() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_edit_fcast_ip_o.GetWindowText(valt);
	GetDocument ()->SetFcastIP(valt);

	
}

void CServerAudioView::OnChangeEditFcastPort() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_edit_fcast_port_o.GetWindowText(valt);
	int vali = atoi(valt.GetBuffer(0));
	GetDocument ()->SetFcastPort(vali);	
}

void CServerAudioView::OnChangeEditFcastRate() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_edit_fcast_rate_o.GetWindowText(valt);
	int vali = atoi(valt.GetBuffer(0));
	GetDocument ()->SetFcastRate(vali);		
}

void CServerAudioView::OnChangeEditFcastRound() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	CString valt;
	m_edit_fcast_round_o.GetWindowText(valt);
	int vali = atoi(valt.GetBuffer(0));
	GetDocument ()->SetFcastRound(vali);		
}
