// ServerInit.cpp: implementation of the CServerInit class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerInit.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CServerInit::CServerInit(CString strFile) : m_strFileName(strFile),	m_cini(strFile) {
	Load ();
}

CServerInit::~CServerInit() {

};

// used to load configuration from file
void CServerInit::Load() {
	// Load configuration
	// [server]
	if (m_cini.sectionExists("Server")){
		// path 
		TCHAR cwdBuffer[MAX_PATH];
		DWORD LenCurDir = GetCurrentDirectory (MAX_PATH, cwdBuffer);
		m_path = m_cini.getKeyValue("path","Server");
		if (m_path == "") { // set default value
			m_path.Format(_T("%s"), cwdBuffer);
		}

		// clientDatabase
		m_clientDb = m_cini.getKeyValue("clientDatabase","Server");
		if (m_clientDb == "") { // set default value
		  m_clientDb.Format(_T("%s\\%s"), cwdBuffer, CLIENT_DB);
		}

		// documentDatabase
		m_docDb = m_cini.getKeyValue("documentDatabase","Server");
		if (m_docDb == "") { // set default value
		  m_docDb.Format(_T("%s\\%s"), cwdBuffer, DOC_DB);
		}

		// documentPath
		m_docPath = m_cini.getKeyValue("documentPath","Server");
		if (m_docPath == "") { // set default value
		  m_docPath.Format(_T("%s\\%s"), cwdBuffer, DOC_PATH);
		}
	
	} else { // section doesn't exist so create keys
		// path
		TCHAR cwdBuffer[MAX_PATH];
		DWORD LenCurDir = GetCurrentDirectory (MAX_PATH, cwdBuffer);
		m_path.Format(_T("%s"), cwdBuffer);
		m_cini.setKey(m_path, "path", "Server");

		// clientDatabase
		m_clientDb.Format(_T("%s\\%s"), cwdBuffer, CLIENT_DB);
		m_cini.setKey(m_clientDb, "clientDatabase", "Server");

		// documentDatabase
		m_docDb.Format(_T("%s\\%s"), cwdBuffer, DOC_DB);
		m_cini.setKey(m_docDb, "documentDatabase", "Server");

		// documentPath
		m_docPath.Format(_T("%s\\%s"), cwdBuffer, DOC_PATH);
		m_cini.setKey(m_docPath, "documentPath", "Server");
	}

	//[TCP]
	if (m_cini.sectionExists("TCP")) {
		// Port
		m_tcpPort = atoi(m_cini.getKeyValue("Port","TCP").GetBuffer (0));
		if (m_tcpPort == 0) { // set default value
			m_tcpPort = TCPPORT;
		}

	} else { // section doesn't exist so create keys
		// Port
		m_tcpPort = TCPPORT;
		CString temp; temp.Format(_T("%d"), m_tcpPort);
		m_cini.setKey(temp, "Port", "TCP");
	}

	//[UDP]
	if (m_cini.sectionExists("UDP")) {
		// MulticastPort
		m_udpPort = atoi(m_cini.getKeyValue("MulticastPort","UDP").GetBuffer (0));
		if (m_udpPort == 0) { // set default value
			m_udpPort = UDPPORT;
		}
		
		// MulticastIP
		m_udpIP = m_cini.getKeyValue("MulticastIP","UDP");
		/*if (m_udpIP == "") { // set default value
			m_udpIP = "12.12.12.12";
		}*/


	} else { // section doesn't exist so create keys
		// MulticastPort
		m_udpPort = UDPPORT;
		CString temp; temp.Format(_T("%d"), m_udpPort);
		m_cini.setKey(temp, "MulticastPort", "UDP");
		
		// MulticastIP
		m_udpIP = MCASTIP;
		m_cini.setKey(temp, "MulticastIP", "UDP");
	}

	//[Fcast]
	if (m_cini.sectionExists("Fcast")) {
		// Round
		m_FcastRound = atoi(m_cini.getKeyValue("FcastRound","Fcast").GetBuffer (0));
		if (m_FcastRound == 0) { // set default value
			m_FcastRound = FCASTROUND;
		}
		// FcastIP
		m_FcastIP = m_cini.getKeyValue("FcastIP","Fcast").GetBuffer (0);
		if (m_FcastIP == "") { // set default value
			m_FcastIP = "230.0.0.2";
		}
		// FcastPort
		m_FcastPort = atoi(m_cini.getKeyValue("FcastPort","Fcast").GetBuffer (0));
		if (m_FcastPort == 0) { // set default value
			m_FcastPort = FCASTPORT;
		}
		// FcastRate
		m_FcastRate = atoi(m_cini.getKeyValue("FcastRate","Fcast").GetBuffer (0));
		if (m_FcastRate == 0) { // set default value
			m_FcastRate = FCASTRATE;
		}
	} else { // section doesn't exist so create keys
		// nbRepeat
		m_FcastRound = FCASTROUND;
		CString temp; temp.Format(_T("%d"), m_FcastRound);
		m_cini.setKey(temp, "FcastRound", "Fcast");

		// FcastIP
		m_FcastIP = "230.0.0.2";
		m_cini.setKey(m_FcastIP, "FcastIP", "Fcast");

		// FcastPort
		m_FcastPort = FCASTPORT;
		temp; temp.Format(_T("%d"), m_FcastPort);
		m_cini.setKey(temp, "FcastPort", "Fcast");
		
		// FcastRate
		m_FcastRate = FCASTRATE;
		temp; temp.Format(_T("%d"), m_FcastRate);
		m_cini.setKey(temp, "FcastRate", "Fcast");
	}

	// Configuration fully Load
};

// used to save configuration to file
BOOL CServerInit::Save() {
	// save configuration to file
	CString temp;
	
	// [Server]
	m_cini.setKey(m_path, "path", "Server");
	m_cini.setKey(m_clientDb, "clientDatabase", "Server");
	m_cini.setKey(m_docDb, "documentDatabase", "Server");
	m_cini.setKey(m_docPath, "documentPath", "Server");

	//[TCP]
	temp.Format (_T("%d"), m_tcpPort);
	m_cini.setKey(temp,"Port","TCP");

	//[UDP]
	temp.Format (_T("%d"), m_udpPort);
	m_cini.setKey(temp, "MulticastPort", "UDP");
	//temp.Format (_T("%d"), m_udpIP);
	m_cini.setKey(m_udpIP, "MulticastIP", "UDP");

	//[Fcast]
	temp.Format (_T("%d"), m_FcastRound);
	m_cini.setKey(temp, "FcastRound", "Fcast");

	m_cini.setKey(m_FcastIP, "FcastIP", "Fcast");

	temp.Format (_T("%d"), m_FcastPort);
	m_cini.setKey(temp, "FcastPort", "Fcast");

	temp.Format (_T("%d"), m_FcastRate);
	m_cini.setKey(temp, "FcastRate", "Fcast");

	return true;
	
};

void CServerInit::SetFile(CString file)
{
	m_strFileName = file;
	m_cini.SetFile(file);
}
