#ifndef _UTILS_H
#define _UTILS_H

//#include <string>

#include <afxsock.h>



extern char WinsockNoError[];
extern char WindsockUnknownError[];

/*
 * All Windows Sockets error constants are biased by WSABASEERR from
 * the "normal"
 * WSABASEERR = 10000 
 */

/*
 * Windows Sockets definitions of regular Microsoft C error constants
 */
extern char* WinsockRegError[];

/*
 * Windows Sockets definitions of regular Berkeley error constants
 */
extern char* WinsockRegBerkError[];


/*
 * Extended Windows Sockets error constant definitions
 */

extern char* WinsockExtError[] ;


/*
 * Error return codes from gethostbyname() and gethostbyaddr()
 * (when using the resolver). Note that these errors are
 * retrieved via WSAGetLastError() and must therefore follow
 * the rules for avoiding clashes with error numbers from
 * specific implementations or language run-time systems.
 * For this reason the codes are based at WSABASEERR+1001.
 * Note also that [WSA]NO_ADDRESS is defined only for
 * compatibility purposes.
 */

extern char* WinsockError2[]; 


char* getWinsockStrError(int err);



void InitSockets();

#endif