// UserInfoManager.cpp: implementation of the UserInfoManager class.
// -----------------------------------------------------------------------
#include "stdafx.h"
#include "UserInfoManager.h"

// -----------------------------------------------------------------------
UserInfoManager::UserInfoManager(CString FileName) : FileName(FileName)
{
  pUserTable = new IRadDataTable<CUserInfo>(FileName);
}
// -----------------------------------------------------------------------
UserInfoManager::~UserInfoManager()
{
  delete pUserTable;
}
// -----------------------------------------------------------------------
BOOL UserInfoManager::RegisterUser(CUserInfo *ui)
{
  return pUserTable->AddRecord(ui);
}
// -----------------------------------------------------------------------
BOOL UserInfoManager::UnRegisterUser(CString login)
{
  return pUserTable->DeleteRecord(login);
}
// -----------------------------------------------------------------------
CUserInfo* UserInfoManager::GetUserInfo (CString login)
{
  return pUserTable->FindRecord(login);
}
// -----------------------------------------------------------------------
void UserInfoManager::ClearDataBase()
{
  pUserTable->ClearAll();
}
// -----------------------------------------------------------------------
void UserInfoManager::GetListAll(CStringList* list)
{
  CUserInfo* ui;

  pUserTable->GotoFirstRecord();
  while( (ui = pUserTable->GetRecord()) != NULL)
  {
      list->AddTail(ui->login);
  }
}
// -----------------------------------------------------------------------
void UserInfoManager::GetList(CStringList* list, BOOL connected)
{
  CUserInfo* ui;

  pUserTable->GotoFirstRecord();
  while( (ui = pUserTable->GetRecord()) != NULL)
  {
    if( ui->connected == connected )
    {
      list->AddTail(ui->login);
    }
  }
}
// -----------------------------------------------------------------------

void UserInfoManager::Flush()
{
	pUserTable->Flush ();
}

void UserInfoManager::setAllOffline(){
	CUserInfo* ui;

  pUserTable->GotoFirstRecord();
  while( (ui = pUserTable->GetRecord()) != NULL)
  {
    ui->connected =false;
  }
}