#include "stdafx.h"
#include "Utils.h"

char WinsockNoError[] = "No Error";
char WindsockUnknownError[] = "Winsock Unknown Error";

/*
 * All Windows Sockets error constants are biased by WSABASEERR from
 * the "normal"
 * WSABASEERR = 10000 
 */

/*
 * Windows Sockets definitions of regular Microsoft C error constants
 */
char* WinsockRegError[] = {
  "","","","",
  "Interrupted system call", // WSAEINTR (WSABASEERR+4) Interrupted system call 
  "","","","",
  "Bad file number", // WSAEBADF (WSABASEERR+9) Bad file number 
  "","","",
  "Permission denied", // WSAEACCES (WSABASEERR+13) Permission denied 
  "Bad address", // WSAEFAULT (WSABASEERR+14) Bad address 
  "","","","","","","","",
  "Invalid argument", // WSAEINVAL (WSABASEERR+22) Invalid argument 
  "",
  "Too many open files", // WSAEMFILE (WSABASEERR+24) Too many open files 
};

/*
 * Windows Sockets definitions of regular Berkeley error constants
 */
char* WinsockRegBerkError[] = {
  "Operation would block", // WSAEWOULDBLOCK (WSABASEERR+35) Operation would block 
  "Operation now in progress", // WSAEINPROGRESS (WSABASEERR+36) Operation now in progress 
  "Operation already in progress", // WSAEALREADY (WSABASEERR+37) Operation already in progress 
  "Socket operation on non-socket", // WSAENOTSOCK (WSABASEERR+38) Socket operation on non-socket 
  "Destination address required", // WSAEDESTADDRREQ (WSABASEERR+39) Destination address required 
  "Message too long", // WSAEMSGSIZE (10040) Message too long 
  "Protocol wrong type for socket", // WSAEPROTOTYPE (WSABASEERR+41) Protocol wrong type for socket 
  "Bad protocol option", // WSAENOPROTOOPT (WSABASEERR+42) Bad protocol option 
  "Protocol not supported", // WSAEPROTONOSUPPORT (WSABASEERR+43) Protocol not supported 
  "Socket type not supported", // WSAESOCKTNOSUPPORT (WSABASEERR+44) Socket type not supported 
  "Operation not supported on socket", // WSAEOPNOTSUPP (WSABASEERR+45) Operation not supported on socket 
  "Protocol family not supported", // WSAEPFNOSUPPORT (WSABASEERR+46) Protocol family not supported 
  "Address family not supported by protocol family", // WSAEAFNOSUPPORT (WSABASEERR+47) Address family not supported by protocol family 
  "Address already in use", // WSAEADDRINUSE (WSABASEERR+48) Address already in use 
  "Can't assign requested address", // WSAEADDRNOTAVAIL (WSABASEERR+49) Can't assign requested address 
  "Network is down", // WSAENETDOWN (WSABASEERR+50) Network is down 
  "Network is unreachable", // WSAENETUNREACH (WSABASEERR+51) Network is unreachable 
  "Net dropped connection or reset", // WSAENETRESET (WSABASEERR+52) Net dropped connection or reset 
  "Software caused connection abort", // WSAECONNABORTED (WSABASEERR+53) Software caused connection abort 
  "Connection reset by peer", // WSAECONNRESET (WSABASEERR+54) Connection reset by peer 
  "No buffer space available", // WSAENOBUFS (WSABASEERR+55) No buffer space available 
  "Socket is already connected ", // WSAEISCONN (WSABASEERR+56) Socket is already connected 
  "Socket is not connected ", // WSAENOTCONN (WSABASEERR+57) Socket is not connected 
  "Can't send after socket shutdown", // WSAESHUTDOWN (WSABASEERR+58) Can't send after socket shutdown 
  "Too many references, can't splice", // WSAETOOMANYREFS (WSABASEERR+59) Too many references, can't splice 
  "Connection timed out", // WSAETIMEDOUT (WSABASEERR+60) Connection timed out 
  "Connection refused", // WSAECONNREFUSED (WSABASEERR+61) Connection refused 
  "Too many levels of symbolic links", // WSAELOOP (10062) Too many levels of symbolic links 
  "File name too long", // WSAENAMETOOLONG (WSABASEERR+63) File name too long 
  "Host is down", // WSAEHOSTDOWN (WSABASEERR+64) Host is down 
  "No Route to Host", // WSAEHOSTUNREACH (WSABASEERR+65) No Route to Host 
  "Directory not empty", // WSAENOTEMPTY (WSABASEERR+66) Directory not empty 
  "Too many processes", // WSAEPROCLIM (WSABASEERR+67) Too many processes 
  "Too many users", // WSAEUSERS (WSABASEERR+68) Too many users 
  "Disc Quota Exceeded", // WSAEDQUOT (WSABASEERR+69) Disc Quota Exceeded 
  "Stale NFS file handle ", // WSAESTALE (WSABASEERR+70) Stale NFS file handle 
  "Too many levels of remote in path", // WSAEREMOTE (WSABASEERR+71) Too many levels of remote in path 
};


/*
 * Extended Windows Sockets error constant definitions
 */
char* WinsockExtError[] = {
  "Network SubSystem is unavailable", // WSASYSNOTREADY (10091) Network SubSystem is unavailable 
  "WINSOCK DLL Version out of range", //WSAVERNOTSUPPORTED (10092) WINSOCK DLL Version out of range 
  "Successful WSASTARTUP not yet performed" //WSANOTINITIALISED (10093) Successful WSASTARTUP not yet performed 
  "","","","","","","",
  "Graceful shutdown in progress", // WSAEDISCON              (WSABASEERR+101)
  "WSAENOMORE", // WSAENOMORE              (WSABASEERR+102)
  "WSAECANCELLED", // WSAECANCELLED           (WSABASEERR+103)
  "WSAEINVALIDPROCTABLE", // WSAEINVALIDPROCTABLE    (WSABASEERR+104)
  "WSAEINVALIDPROVIDER", // WSAEINVALIDPROVIDER     (WSABASEERR+105)
  "WSAEPROVIDERFAILEDINIT", // WSAEPROVIDERFAILEDINIT  (WSABASEERR+106)
  "WSASYSCALLFAILURE", // WSASYSCALLFAILURE       (WSABASEERR+107)
  "WSASERVICE_NOT_FOUND", // WSASERVICE_NOT_FOUND    (WSABASEERR+108)
  "WSATYPE_NOT_FOUND", // WSATYPE_NOT_FOUND       (WSABASEERR+109)
  "WSA_E_NO_MORE", // WSA_E_NO_MORE           (WSABASEERR+110)
  "WSA_E_CANCELLED", // WSA_E_CANCELLED         (WSABASEERR+111)
  "WSAEREFUSED", // WSAEREFUSED             (WSABASEERR+112)
};


/*
 * Error return codes from gethostbyname() and gethostbyaddr()
 * (when using the resolver). Note that these errors are
 * retrieved via WSAGetLastError() and must therefore follow
 * the rules for avoiding clashes with error numbers from
 * specific implementations or language run-time systems.
 * For this reason the codes are based at WSABASEERR+1001.
 * Note also that [WSA]NO_ADDRESS is defined only for
 * compatibility purposes.
 */

char* WinsockError2[] = {
  "Host not found", // WSAHOST_NOT_FOUND (11001) Host not found 
  "Non-Authoritative Host not found", // WSATRY_AGAIN (11002) Non-Authoritative Host not found 
  "Non-Recoverable errors: FORMERR, REFUSED, NOTIMP", // WSANO_RECOVERY (11003) Non-Recoverable errors: FORMERR, REFUSED, NOTIMP 
  "Valid name, no data record of requested type, No address", // WSANO_DATA (11004)* Valid name, no data record of requested type 
};

//------------------------------------------------------------------------
char* getWinsockStrError(int err) {
  if(err==0) {
    return WinsockNoError;
  } else if(err & WSABASEERR) {
    int errCodeRelatif=err - WSABASEERR;
    if(errCodeRelatif>=0 && errCodeRelatif<=24)
      return WinsockRegError[errCodeRelatif];
    else if(errCodeRelatif>=35 && errCodeRelatif<=72)
      return WinsockRegBerkError[errCodeRelatif-35];
    else if(errCodeRelatif>=91 && errCodeRelatif<=112)
      return WinsockExtError[errCodeRelatif-91];
    else if(errCodeRelatif>=1001 && errCodeRelatif<=1004)
      return WinsockError2[errCodeRelatif-1001];
    return WindsockUnknownError;
  } else {
    return WindsockUnknownError;
  }
}
//------------------------------------------------------------------------


void InitSockets(){
	WORD wVersionRequested = MAKEWORD(1, 1);
	WSADATA wsaData;
	int res;

	res = WSAStartup(wVersionRequested, &wsaData);
	if (res != 0) exit(0);
	if (LOBYTE(wsaData.wVersion)!=1 || HIBYTE(wsaData.wVersion)!=1){
		WSACleanup();
		exit(0);
	}
};